<?php
/**
 * Glossword - glossary compiler (http://glossword.info/dev/)
 *  2002-2005 Dmitry N. Shilnikov <dev at glossword.info>
 */
/**
 * Login process.
 */
/* Turn on any warnings */
error_reporting(E_ALL);
/* Load login configuration */
if (!include("login.cfg.php"))
{
	print 'sys: Can\'t include login.cfg.php. Check configuration.';
	exit;
}
/* Change current directory to access for website files */
if (!chdir($path['doc_root']))
{
	print 'sys: Can\'t change directory to ' . $path['doc_root']. '. Check login.cfg.php';
	exit;
}
/* Load website configuration */
$sys['path_gwlib'] = 'lib';
$sys['path_include'] = 'inc';
$sys['path_include_local'] = 'inc';
$sys['is_prepend'] = 1;
include_once('db_config.php');
include_once($sys['path_include_local'] . '/config.inc.php');

$sys['visualtheme'] = 'gw_silver';
/* Allow user when installation is locked */
#if (!file_exists($sys['file_lock']))
#{
#	print 'Installer is not locked';
#	exit;
#}
if (!defined('GW_DB_HOST'))
{
	print "sys: Can't find config.inc.php GW_DB_HOST is not defined.";
	exit;
}
/* */
include_once( $sys['path_include'] . '/class.forms.'      . $sys['phpEx'] );
include_once( $sys['path_include'] . '/func.admin.inc.'   . $sys['phpEx'] );
/* --------------------------------------------------------
 * Database -> Query storage
 * ----------------------------------------------------- */
$oDb = new gwtkDb;
$oSqlQ = new $sys['class_queries'];
$oSqlQ->set_suffix('-'.$sys['db_type']);
/* ------------------------------------------------------- */
/* Append system settings */
$sys = array_merge($sys, getSettings());
/* Fill empty settings */
$sys['visualtheme'] = isset($sys['visualtheme']) ? $sys['visualtheme'] : 'gw_silver';
$sys['is_mod_rewrite']  = 0;
$tmps = array();
/* --------------------------------------------------------
 * Register global variables
 * ----------------------------------------------------- */
$gw_this['vars'] = $oGlobals->register(array(
	GW_ACTION,GW_ID_DICT,'p','r',GW_TARGET,'arPost','visualtheme',
	'id','cookie',GW_SID,'post','actkey',
	GW_LANG_I, GW_LANG_C
));

    $themefile = $sys['path_tpl'] . '/' . $sys['visualtheme'] . '/theme.inc.' . $sys['phpEx'];
    if (file_exists($themefile))
    {
        include_once( $themefile );
    }
    else
    {
        die("Can't find " . $themefile);
    }
##------------------------------------------------


/* --------------------------------------------------------
 * mod_rewrite configuration
 * ------------------------------------------------------- */
$sys['is_mod_rewrite'] = 0;
$oHtml = new gw_html;
$oHtml->setVar('is_htmlspecialchars', 0);
$oHtml->setVar('is_mod_rewrite', $sys['is_mod_rewrite']);
$oHtml->is_append_sid = 1;
$oHtml->id_sess_name = 'sid';


/* Translation engine */
$oL = new gwtk;
$oL->setHomeDir($sys['path_locale']);
$oL->setLocale($sys['locale_name']);
$oL->getCustom('admin', $sys['locale_name'], 'join');
$oL->getCustom('err', $sys['locale_name'], 'join');
$oL->getCustom('mail', $sys['locale_name'], 'join');
$sys['css_align_right'] = 'right';
$sys['css_align_left'] = 'left';
if ($oL->languagelist('1') == 'rtl')
{
	$sys['css_align_right'] = 'left';
	$sys['css_align_left'] = 'right';
}
/* Redirect URL */
$url_admin = $sys['server_proto'] . $sys['server_host'] . $sys['page_admin'];

/* */
$oTpl = new gwTemplate();
$oTpl->addVal( 'LANG',           $oL->languagelist("0") );
$oTpl->addVal( 'TEXT_DIRECTION', $oL->languagelist("1") );
$oTpl->addVal( 'CHARSET',        $oL->languagelist("2") );
$oTpl->addVal( 'L_securenot',    $oL->m('securenote') );
$oTpl->addVal( 'TITLE',          $sys['site_name']);
$oTpl->addVal( 'PATH_CSS',       '.' );
$ar_tpl_construct = array( $sys['path_admin'] . '/' . $sys['path_tpl'] . '/login.html');

$tmp['ar_req'] = array('user_name', 'user_pass');
/* */
$gw_this['str_status'] = '';

/* Start session */
$oSess = new $sys['class_session'];
/* Session-protected area below */
$oSess->start();

/* Activation key  */
if ($gw_this['vars']['actkey'])
{
	/*
		1) get login, email, name based on activation key
		2) create password
		3) create mail message
		4) send mail
		5) update database
		6) redirect to login page
	*/
	$sql = $oSqlQ->getQ('get-user-by-actkey', $gw_this['vars']['actkey']);
	$arSql = $oDb->sqlExec($sql);
	$tmps['is_exists'] = 0;
	while (list($k, $arV) = each($arSql))
	{
		$tmps['is_exists'] = 1;
		$tmps['id_auth'] = $arV['id_auth'];
		$tmps['user_name'] = $arV['user_name'];
		$tmps['user_email'] = $arV['user_email'];
		$tmps['login'] = $arV['login'];
	}
	if ($tmps['is_exists'])
	{
		$login_url = $sys['server_proto'] . $sys['server_host'] . $sys['page_login'];
		$login_url = '<a href="'.$login_url.'" onclick="window.open(this.href);return false;">'.$login_url.'</a>';
		$str_pass = kMakeUid('', 8, 1);
		/* Prepare message */
		/* User name, URL, login, password, message template */
		$msgBody = gwCreateMessage($tmps['user_name'], $login_url, $tmps['login'], $str_pass, 'mail_newuser.html');
		if (!kMailTo($tmps['user_email'], $sys['y_email'], '', $msgBody, 0))
		{
			$gw_this['str_status'] .= '<p><span class="s"><b>' .sprintf($oL->m('reason_17'), $tmps['user_email']). '</b></span></p>';
			/* display login and password */
			$gw_this['str_status'] .= '<p>'.$oL->m('login'). ': <b>' . $tmps['login'] . '</b><br /> '.
				 $oL->m('password'). ': <b>' . $str_pass . '</b></p>';
		}
		/* Set new password */
		$sql1 = $oSqlQ->getQ('set-password', md5($str_pass), $tmps['id_auth']);
		$sql2 = $oSqlQ->getQ('set-user-active', '1', '', $tmps['id_auth']);
		/* Activate account */
		if ($oDb->sqlExec($sql1) && $oDb->sqlExec($sql2))
		{
			$gw_this['str_status'] .= '<p>' . $oL->m('reason_24') . '</p>';
		}
	}
	else
	{
		$gw_this['str_status'] .= '<p><span class="s"><b>' . $oL->m('reason_23') . '</b></span></p>';
	}
#	$gw_this['vars']['post'] = 1;
}
/* */
if ($oSess->user_get('perm_level') > 1)
{
	/* Auth successful */
	gwtk_header(append_url($url_admin), $sys['is_delay_redirect']);
}
/* Not posted */
if ($gw_this['vars']['post'] == '')
{
	$gw_this['vars']['arPost']['user_name'] =
	$gw_this['vars']['arPost']['user_pass'] =
	$gw_this['vars']['arPost']['user_email'] = '';
	$oTpl->addVal( 'non::objLogin',  $oSess->get_htmlform($gw_this['vars']['arPost'], array(), $tmp['ar_req']));
}
else
{
	$gw_this['vars']['arPost']['user_pass'] = isset($gw_this['vars']['arPost']['user_pass'])
											? $gw_this['vars']['arPost']['user_pass']
											: '';
	if ($gw_this['vars'][GW_ACTION] == 'login')
	{
		/* Check login & pass  */
		/* Set default error */
		$gw_this['str_status'] = '<p>' . $oL->m('reason_20') . '</p>';
		switch ($oSess->auth_login($gw_this['vars']['arPost']))
		{
			case 0:
				/* Login failed */
				$oTpl->addVal( 'non::objLogin',  $oSess->get_htmlform($gw_this['vars']['arPost'], array(), $tmp['ar_req']));
			break;
			case 1:
				/* Login successful */
				gwtk_header(append_url($url_admin), $sys['is_delay_redirect']);
			break;
			case 2:
				/* Inactive account */
				$gw_this['str_status'] = '<p>' . $oL->m('reason_21') . '</p>';
				$oTpl->addVal( 'non::objLogin',  $oSess->get_htmlform($gw_this['vars']['arPost'], array(), $tmp['ar_req']));
			break;
		}
	}
	elseif ($gw_this['vars'][GW_ACTION] == 'lostpass')
	{
		$sql = $oSqlQ->getQ('cmp-login-email', $gw_this['vars']['arPost']['user_name'], $gw_this['vars']['arPost']['user_email']);
		$arSql = $oDb->sqlExec($sql);
		$tmps['is_exists'] = 0;
		$tmps['id_auth'] = 0;

		while (list($k, $arV) = each($arSql))
		{
			$tmps['is_exists'] = 1;
			$tmps['id_auth'] = $arV['id_auth'];
			$tmps['login'] = $arV['login'];
		}
		if ($tmps['is_exists'])
		{
			/* Create new password */
			$gw_this['str_status'] = '<p>'.$oL->m('reason_22').'</p>';
			$actkey = kMakeUid('k', $maxchar = 16, 1);
			$actkey_url = $sys['server_proto'] . $sys['server_host'] . $sys['page_login'] . '?' . 'actkey=' . $actkey;
			$actkey_url = '<a href="'.$actkey_url.'">'.$actkey_url.'</a>';
			$mail_sig = $sys['site_name'] . ' - ' . $sys['site_desc'];
			$arSrc = array('{USERNAME}', '{SITENAME}', '{U_ACTIVATE}');
			$arTrg = array($tmps['login'], $sys['site_name'], $actkey_url);
			$msgBody = str_replace($arSrc, $arTrg, $oL->m('mail_newpass'));
			$msgSubj = str_replace($arSrc, $arTrg, $oL->m('mail_newpass_subj'));
			/* */
			$tpl_mail = new gwTemplate();
			$tpl_mail->addVal( 'LANG',           $oL->languagelist("0") );
			$tpl_mail->addVal( 'TEXT_DIRECTION', $oL->languagelist("1") );
			$tpl_mail->addVal( 'CHARSET',        $oL->languagelist("2") );
			$tpl_mail->addVal( 'EMAIL_SIG',      $mail_sig );
			$tpl_mail->addVal( 'MSG_NEWPASS',    $msgBody );
			$tpl_mail->addVal( 'SUBJECT',        $msgSubj );
			$tpl_mail->setHandle(0, $sys['path_admin'] . '/' . $sys['path_tpl'] . '/mail_newpass.html');
			$tpl_mail->parse();
			$msgBody = $tpl_mail->output();
			/* */
			if (!kMailTo($gw_this['vars']['arPost']['user_email'], $sys['y_email'], $msgSubj, $msgBody, 0))
			{
				$gw_this['str_status'] .= '<p><span class="s"><b>'.sprintf($oL->m('reason_17'), $gw_this['vars']['arPost']['user_email']).'</b></span></p>';
				/* display activation key */
				$gw_this['str_status'] .= '<p>' . $actkey_url . '</p>';
			}
			/* Disable account and set activation key */
			$sql = $oSqlQ->getQ('set-user-active', '0', $actkey, $tmps['id_auth']);
			$oDb->sqlExec($sql);
		}
		else
		{
			/* No such account */
			$gw_this['str_status'] = '<p>'.$oL->m('reason_20').'</p>';
		}
		$oTpl->addVal( 'non::objLogin',  $oSess->get_htmlform($gw_this['vars']['arPost'], array(), $tmp['ar_req']));
	}
}
/* Current status */
$oTpl->addVal('non::objStatus', $gw_this['str_status']);
/* Render page */
if ( isset($ar_tpl_construct) && is_array($ar_tpl_construct) )
{
	for (reset($ar_tpl_construct); list($k, $v) = each($ar_tpl_construct); )
	{
		$oTpl->setHandle( $k , $v );
	}
}
$oTpl->parse();
$oHdr->add('Expires: ' . gmdate("D, d M Y H:i:s") . ' GMT');
$oHdr->add('Last-Modified: ' . gmdate("D, d M Y H:i:s") . ' GMT');
$oHdr->add('Cache-Control: no-cache, must-revalidate');
$oHdr->add('Pragma: no-cache');
$oHdr->add('Content-Type: text/html; charset='.$oL->languagelist('2'));
$oHdr->output();
print $oTpl->output();
/* Close session */
$oSess->user_close();
/* end of file */
?>