<?php
/*
 * Query storage
 *  2004-2005 Dmitry N. Shilnikov <dev at glossword.info>
 * $Id: query_storage_global-mysql410.php,v 1.1 2005/06/07 16:51:23 yrtimd Exp $
 */
$tmp['ar_queries'] = array(
	'get-custompages-lang' => 'SELECT gp.id_page, gpph.id_lang
						FROM '.TBL_CUSTOMPAGES.' AS gp, '.TBL_CUSTOMPAGES_PH.' AS gpph
						WHERE %s
						AND gp.id_page = gpph.id_page
						AND gp.is_active = "1"
						GROUP BY gpph.id_lang
					',
	'get-custompages-lang-adm' => 'SELECT gpph.page_title, gpph.page_content, gpph.page_descr, gpph.id_lang, gpph.id_page_phrase
						FROM '.TBL_CUSTOMPAGES.' AS gp, '.TBL_CUSTOMPAGES_PH.' AS gpph
						WHERE gp.id_page = %d
						AND gp.id_page = gpph.id_page
						GROUP BY gpph.id_lang
					',
	'get-custompages' => 'SELECT gp.id_page, gp.date_created, gp.date_modified, gp.page_php_1, gp.page_php_2, gp.page_icon,
						gpph.page_title, gpph.page_descr, gpph.page_content, gpph.id_lang
						FROM '.TBL_CUSTOMPAGES.' AS gp, '.TBL_CUSTOMPAGES_PH.' AS gpph
						WHERE %s
						AND gpph.id_lang = "%s"
						AND gp.id_page = gpph.id_page
						AND gp.is_active = "1"
						LIMIT 1
					',
	'get-custompages-adm' => 'SELECT gp.is_active, gp.date_created, gp.date_modified, gp.page_php_1, gp.page_php_2, 
						gp.page_icon, gp.page_uri
						FROM '.TBL_CUSTOMPAGES.' AS gp
						WHERE gp.id_page = %d
					',
	'get-custompages_id-by-title' => 'SELECT gp.id_page, gpph.page_title
						FROM '.TBL_CUSTOMPAGES.' AS gp, '.TBL_CUSTOMPAGES_PH.' AS gpph
						WHERE gp.id_page = gpph.id_page
						GROUP BY gp.id_page
						ORDER BY gpph.id_lang, gpph.page_title
					',
	'get-custompages_id-by-p' => 'SELECT gp.id_page, gpph.page_title, gpph.page_descr
						FROM '.TBL_CUSTOMPAGES.' AS gp, '.TBL_CUSTOMPAGES_PH.' AS gpph
						WHERE gp.id_page = gpph.id_page
						AND gp.id_parent = "%d"
						GROUP BY gp.id_page
						ORDER BY gpph.id_lang, gpph.page_title
					',	
	'get-settings' => 'SELECT settings_key, settings_val
						FROM ' . TBL_SETTINGS.'
					',
	'get-topics' => 'SELECT id, s, p, tpname
						FROM ' . TBL_TPCS . '
						ORDER BY p ASC, s ASC, tpname
					',
	'get-dicts-admin' => 'SELECT tp.tpname, tp.id AS p, d.*
						FROM ' . TBL_DICT . ' AS d, ' . TBL_TPCS . ' AS tp
						WHERE tp.id = d.id_tp
						ORDER BY d.title, d.is_active, d.lang
					',
	'get-dicts-web' => 'SELECT tp.tpname, tp.id AS p, d.*
						FROM ' . TBL_DICT . ' AS d, ' . TBL_TPCS . ' AS tp
						WHERE d.is_active = "1"
						AND tp.id = d.id_tp
						ORDER BY tp.tpname, d.lang, d.title
					',
	'get-dict' => 'SELECT u.user_name, u.user_email, u.location, u.is_showcontact, d.*
						FROM ' . TBL_DICT . ' AS d, ' . TBL_USERS . ' AS u
						WHERE d.id = "%d"
						AND d.id_user = u.id_user
						AND d.is_active = "1"
					',
	'get-terms-total' => 'SELECT count(*) AS num, SUM(int_terms) AS sum
						FROM ' . TBL_DICT . '
						WHERE is_active = "1"
					',
	'top-dict-updated' => 'SELECT d.id, d.date_modified, s.hits, d.title
						FROM ' . TBL_DICT . ' AS d, ' . TBL_STAT_DICT . ' AS s
						WHERE d.is_active = "1"
						AND d.id = s.id
						ORDER BY d.date_modified DESC LIMIT 0, %d
					',
	'top-dict-hits-avg' => 'SELECT d.id, s.hits, d.title, (s.hits / ((%d - d.date_created) / 86400) ) AS hits_avg
						FROM ' . TBL_DICT . ' AS d, ' . TBL_STAT_DICT . ' AS s
						WHERE d.is_active = "1"
						AND d.id = s.id
						ORDER BY hits_avg DESC, s.hits DESC, d.int_terms ASC, d.title ASC LIMIT 0, %d
					',
	'top-dict-new' => 'SELECT d.id, d.date_created, s.hits, d.title
						FROM ' . TBL_DICT . ' AS d, ' . TBL_STAT_DICT . ' AS s
						WHERE d.is_active = "1"
						AND d.id = s.id
						ORDER BY d.date_created DESC LIMIT 0, %d
					',
	'top-term-new' => 'SELECT id, date_modified, term
						FROM %s
						WHERE is_active = "1"
						ORDER BY date_modified DESC, term LIMIT 0, %d
					',
	'top-term-new-adm' => 'SELECT id, date_modified, term
						FROM %s
						ORDER BY date_modified DESC, term LIMIT 0, %d
					',
	'up-dict-hits' => 'UPDATE ' . TBL_STAT_DICT . '
						SET hits = hits + 1
						WHERE id = "%d"
					',
	'get-az' => 'SELECT t.term_1 AS L1, t.term_2 AS L2
						FROM %s AS t
						WHERE t.is_active = "1"
						GROUP BY t.term_1, t.term_2
						ORDER BY t.term_1, t.term_2, t.term
					',
	'get-tb-by-id_lang' => 'SELECT tb.int_sort, tb.character as L1
						FROM %s AS tb
						WHERE tb.id_lang = "%s"
						ORDER BY tb.int_sort
					',
	'get-tb-by-char' => 'SELECT tb.int_sort, tb.character as L1
						FROM %s AS tb
						WHERE tb.id_lang = "%s"
						AND tb.character in ("%s")
						ORDER BY tb.id_lang, tb.int_sort
					',
	'get-term-by-id' => 'SELECT id AS tid, is_active, term_1, term_2, term, defn
						FROM %s
						WHERE is_active = "1"
						AND id = "%d"
						',
	'get-term-by-id-adm' => 'SELECT id AS tid, is_active, term_1, term_2, term, defn
						FROM %s
						WHERE id = "%d"
					',
	'get-term-by-name' => 'SELECT t.id as tid, t.is_active, t.term_1, t.term_2, t.term, t.defn
						FROM %s AS k, %s AS m, %s AS t
						WHERE is_active = "1"
						AND m.dict_id = "%d"
						AND m.term_match = "1"
						AND k.word_id = m.word_id
						AND t.id = m.term_id
						AND k.word_text IN (%s)
						GROUP BY m.term_id
					',
	'get-term-by-name-adm' => 'SELECT t.id as tid, t.is_active, t.term_1, t.term_2, t.term, t.defn
						FROM %s AS k, %s AS m, %s AS t
						WHERE m.dict_id = "%d"
						AND m.term_match = "1"
						AND k.word_id = m.word_id
						AND t.id = m.term_id
						AND k.word_text IN (%s)
						GROUP BY m.term_id
					',
	'cnt-term' => 'SELECT count(*) AS n
						FROM %s
					',
	'cnt-term-by-t1' => 'SELECT count(*) AS n
						FROM %s
						WHERE is_active = "1"
						AND term_1 = "%s"
					',
	'cnt-term-by-t1t2' => 'SELECT count(*) AS n
						FROM %s
						WHERE is_active = "1"
						AND term_1 = "%s"
						AND term_2 = "%s"
					',
	'get-term-by-t1' => 'SELECT id AS t_id, term, int_bytes, %s
						FROM %s
						WHERE is_active = "1"
						AND term_1 = "%s"
						ORDER BY term_2 ASC, term ASC
					',
	'get-term-by-t1t2' => 'SELECT id AS t_id, term, int_bytes, %s
						FROM %s
						WHERE is_active = "1"
						AND term_1 = "%s"
						AND term_2 = "%s"
						ORDER BY term_2 ASC, term ASC
					',
	'get-term-by-page' => 'SELECT id AS t_id, term, int_bytes, %s
						FROM %s
						WHERE is_active = "1"
						ORDER BY term_2 ASC, term ASC
						%s
					',
	'srch-word-cnt' => 'SELECT m.term_id, m.dict_id
						FROM ' . TBL_WORDLIST . ' AS k, ' . TBL_WORDMAP . ' AS m
						WHERE m.dict_id IN (%s) %s
						AND k.word_id = m.word_id
						AND %s
						GROUP BY m.term_id
					',
	'srch-result-cnt' => 'SELECT hits FROM '.TBL_SRCH_RESULTS.'
						WHERE id_srch = "%s"
					',
	'srch-result-id' => 'SELECT * FROM '.TBL_SRCH_RESULTS.'
						WHERE id_srch = "%s"
					',
	'get-terms-in' => 'SELECT id as id_t, term, defn 
						FROM %s
						WHERE id IN (%s)
						AND is_active = "1"
						ORDER BY term_2, term_1, term %s
					',
	'get-terms-in-adm' => 'SELECT id as id_t, is_active, term, defn 
						FROM %s
						WHERE id IN (%s)
						ORDER BY is_active DESC, term_2, term_1, term %s
					',
	'upd-srch-results++' => 'UPDATE '.TBL_SRCH_RESULTS.'
						SET hits = "%d"
						WHERE id_srch = "%s"
					',
	'upd-srch-q' => 'UPDATE '.TBL_SRCH_RESULTS.'
						SET hits = "%d", q = "%s"
						WHERE id_srch = "%s"
					',
	'create-dict' => "CREATE TABLE `%s` (
						`id` int(10) unsigned NOT NULL default '0',
						`is_active` enum('0','1') NOT NULL default '1',
						`date_modified` int(10) unsigned NOT NULL default '0',
						`date_created` int(10) unsigned NOT NULL default '0',
						`int_bytes` mediumint(6) unsigned NOT NULL default '0',
						`term_1` varbinary(6) NOT NULL default '',
						`term_2` varbinary(12) NOT NULL default '',
						`term` varbinary(255) NOT NULL default '',
						`defn` mediumblob NOT NULL,
						PRIMARY KEY (`id`)
					 ) ENGINE=MyISAM DEFAULT CHARSET=utf8
					",
	'get-term-exists' => 'SELECT t.id, t.term
						FROM %s AS k, '.TBL_WORDMAP.' AS m, %s AS t
						WHERE m.dict_id = "%d"
						AND m.term_match = "%d"
						AND k.word_id = m.word_id
						AND t.id = m.term_id
						AND %s
						GROUP BY m.term_id
					',
	'get-term-exists-spec' => 'SELECT t.id, t.term
						FROM %s AS t
						WHERE t.term LIKE "%s"
						GROUP BY t.id
					',
	'get-term-rand' => 'SELECT t.term, t.defn
						FROM %s as t
						WHERE LENGTH(t.defn) < 4096
						ORDER BY RAND()
						LIMIT 0, 1
					',
	'get-term-export' => 'SELECT term_1, term_2, id, term, defn
						FROM %s as t
						WHERE %s
						ORDER BY t.term
						%s
					',
	'get-word' => 'SELECT word_text, word_id
						FROM %s
						WHERE word_text IN (%s)
					',
	'del-wordmap-by-term-dict' => 'DELETE FROM '.TBL_WORDMAP.'
						WHERE term_id = "%d"
						AND dict_id = "%d"
					',
	'get-terms-all' => 'SELECT t.id as term_id
						FROM %s AS t
						WHERE t.is_active = "1"
						GROUP BY id
						ORDER BY t.term_1 ASC, t.term_2 ASC, t.term ASC
					',
	'get-terms-all-adm' => 'SELECT t.id as term_id
						FROM %s AS t
						GROUP BY id
						ORDER BY t.term_1 ASC, t.term_2 ASC, t.term ASC
					',
	'get-date-mm' => 'SELECT MIN(date_created) AS min, MAX(date_created) AS max
						FROM %s
					',
	'cnt-dict-date' => 'SELECT count(*) AS n
						FROM %s
						WHERE date_modified >= %s
						AND date_modified <= %s
					',
	'get-users-edit' => 'SELECT *
						FROM ' . TBL_USERS . '
						WHERE perm_level < 16
						AND perm_level >= 2
						ORDER BY date_reg
					',
	'get-pages-edit' => 'SELECT gpph.page_title, gpph.id_lang, gp.id_page, gp.is_active, gp.int_sort, gp.id_parent as p
						FROM ' . TBL_CUSTOMPAGES . ' as gp, ' . TBL_CUSTOMPAGES_PH . ' as gpph
						WHERE gp.id_page = gpph.id_page
						ORDER BY gp.id_parent ASC, gp.int_sort ASC, id_lang
					',
	'get-pages-list' => 'SELECT gpph.page_title, gpph.id_lang, gp.id_page, gp.page_uri, gp.page_icon, gp.page_php_2, gp.int_sort
						FROM ' . TBL_CUSTOMPAGES . ' as gp, ' . TBL_CUSTOMPAGES_PH . ' as gpph
						WHERE gp.id_page = gpph.id_page
						AND gp.is_active = "1"
						AND gp.id_parent = "0"
						ORDER BY gp.int_sort ASC
					',
	'get-subpages-list' => 'SELECT gpph.page_title, gpph.page_descr, gpph.id_lang, 
							gp.id_page, gp.page_uri, gp.id_parent as p, gp.page_icon, gp.page_php_2, gp.int_sort
						FROM ' . TBL_CUSTOMPAGES . ' as gp, ' . TBL_CUSTOMPAGES_PH . ' as gpph
						WHERE gp.id_page = gpph.id_page
						AND gp.is_active = "1"
						ORDER BY gp.int_sort ASC
					',
	'get-dict-valid' => 'SELECT d.id, d.tablename
						FROM ' . TBL_DICT . ' AS d, ' . TBL_STAT_DICT . ' AS s
						WHERE d.is_active = "1"
						AND d.id = s.id
						ORDER BY d.int_terms, d.title
					',
	'rename-tbl' => 'ALTER TABLE `%s` RENAME `%s`',
	'del-srch-by-date' => 'DELETE
						FROM '.TBL_SRCH_RESULTS.'
						WHERE srch_date < (UNIX_TIMESTAMP(NOW())-%d)
					',
	'del-by-id' => 'DELETE FROM %s WHERE id = %d',
	'del-by-dict_id' => 'DELETE FROM %s WHERE dict_id = "%d"',
	'del-term_id' => 'DELETE FROM %s WHERE id = "%s"',
	'del-term_id-dict_d' => 'DELETE FROM %s WHERE term_id = "%s" AND dict_id = "%d"',
	'del-term_id-id_d' => 'DELETE FROM %s WHERE term_id = "%s" AND id_d = "%d"',
	'del-srch-by-dict' => 'DELETE FROM '.TBL_SRCH_RESULTS.' WHERE id_d = "%d"',
	'del-table' => 'DELETE FROM %s',
	'del-wordmap-by-dict' => 'DELETE FROM '.TBL_WORDMAP.' WHERE dict_id = "%d"',
	'drop-table' => 'DROP TABLE IF EXISTS %s'
);

?>