<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: t.dict.inc.php,v 1.17 2005/06/09 06:32:03 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2005 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Actions for a dictionary. Add, Browse, Edit, Remove, Update.
 */
// --------------------------------------------------------
/**
 * HTML-form for dictionary
 *
 * @param    array   $vars       posted variables
 * @param    int     $runtime    is this form posted first time [ 0 - no | 1 - yes ] // todo: bolean
 * @param    array   $arBroken   the names of broken fields (after post)
 * @param    array   $arReq      the names of required fields (after post)
 * @return   string  complete HTML-code
 * @see textcodetoform(), getFormHeight()
 */
function getFormDict($vars, $runtime = 0, $arBroken = array(), $arReq = array())
{
	global $arFields, ${GW_ACTION}, $oL, ${GW_SID}, $oFunc, $oSess;
	global $sys, $gw_this, $id, $tid, $topic_mode;
	$topic_mode = "form";
	$strForm = "";

	$trClass = "t";
	$v_class_1 = "td1";
	$v_class_2 = "td2";
	$v_td1_width = '20%';
	$trDisabled = "disabled";

	$form = new gwForms();

	$form->Set('action', $GLOBALS['sys']['page_admin']);
	$form->Set('submitok', $oL->m('3_save'));
	$form->Set('submitcancel', $oL->m('3_cancel'));
	$form->Set('formbgcolor', $GLOBALS['theme']['color_2']);
	$form->Set('formbordercolor', $GLOBALS['theme']['color_4']);
	$form->Set('formbordercolorL', $GLOBALS['theme']['color_1']);
	$form->Set('align_buttons', $GLOBALS['sys']['css_align_right']);
	$form->Set('charset', $sys['internal_encoding']);

	$form->Set('isButtonCancel', 1);
	$form->Set('isButtonSubmit', 0);

	$form->arLtr = array('arPost[visualtheme]', 'arPost[lang]', 'arPost[tablename]');
	## ----------------------------------------------------
	##
	// reverse array keys <-- values;
	$arReq = array_flip($arReq);
	// mark fields as "REQUIRED" and make error messages
	while(is_array($vars) && list($key, $val) = each($vars) )
	{
		$arReqMsg[$key] = $arBrokenMsg[$key] = "";
		if (isset($arReq[$key])) { $arReqMsg[$key] = '&#160;<span class="red"><b>*</b></span>'; }
		if (isset($arBroken[$key])) { $arBrokenMsg[$key] = ' <span class="red"><b>' . $oL->m('reason_9') .'</b></span>'; }
	} // end of while
	##
	## ----------------------------------------------------
	$ar = gw_create_tree_topics();
	//
	$strForm .= getFormTitleNav($oL->m('sect_general'), '');
	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr>';

	$tmp['ar_languages'] = $oL->getLanguages();

	/* Search length */
	$arNums = array(0 => $oL->m('1038'), 1, 2, 3, 4, 5);

	if (${GW_ACTION} == GW_A_ADD)
	{
		$form->Set('isButtonSubmit', 1);
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field("checkbox", "arPost[is_active]", $vars['is_active']) . '</td>'.
					'<td class="'.$v_class_2.'">' . '<label for="'.$form->text_field2id('arPost[is_active]').'">'.$oL->m('allow_dict').'</label></td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('dict_name') . ':' . $arReqMsg['title'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['title'] . $form->field("textarea", "arPost[title]", textcodetoform($vars['title']), 3) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('descr') . ':</td>'.
					'<td class="'.$v_class_2.'">' . $form->field("textarea", "arPost[description]", textcodetoform($vars['description']), 7) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('topic')  . ':' . $arReqMsg['id_tp'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['id_tp'].
					'<select class="input50" name="arPost[id_tp]">' . ctlgGetTopicsRow($ar, 0, 1) . '</select>' .
					'</td>'.
					'</tr>';
		$strForm .= '</table>';
		/* */
		$strForm .= getFormTitleNav($oL->m('sect_visual'), '');
		$form->setTag('select', 'class',  'input50');
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('default_lang')  . ':' . $arReqMsg['lang'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $form->field("select", "arPost[lang]", $vars['lang'], '0', $tmp['ar_languages']) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('themename') . ':' . $arReqMsg['visualtheme'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $form->field("select", "arPost[visualtheme]", $vars['visualtheme'], 0, $gw_this['ar_themes']) . '</td>'.
					'</tr>';
		$strForm .= '</table>';

		/* Search settings */
		$strForm .= getFormTitleNav($oL->m('Search settings'), '');
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tbody><tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';

		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('min_srch_length') . ':' . $arReqMsg['min_srch_length'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $form->field("select", "arPost[min_srch_length]", $vars['min_srch_length'], 0, $arNums ) . '</td>'.
					'</tr>';

		$strForm .= '</tbody></table>';
		/* */
	
		$strForm .= getFormTitleNav($oL->m('sect_system'), '');
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('sysname') . ':' . $arReqMsg['tablename'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['tablename'] . $form->field("input", "arPost[tablename]", textcodetoform( $vars['tablename'] ) ) . '</td>'.
					'</tr>';
		$strForm .= '</table>';
		$strForm .= $form->field("hidden", GW_ACTION, GW_A_ADD);
		$strForm .= $form->field("hidden", GW_TARGET, GW_T_DICT);
		$strForm .= $form->field("hidden", "arPost[uid]", $vars['tablename']);
		$form->unsetTag('select');

	}
	else
	{
		$form->setTag('select', 'class',  'input50');
		/* Editing the dictionary settings */

		/* Editing allowed */
		if ($oSess->is_allow('dict_edit', $vars['id'])
			|| ($vars['id_user'] == $oSess->id_user))
		{
		$form->Set('isButtonSubmit', 1);
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field("checkbox", "arPost[is_active]", $vars['is_active']) . '</td>'.
					'<td class="'.$v_class_2.'">' . '<label for="'.$form->text_field2id('arPost[is_active]').'">'.$oL->m('allow_dict').'</label></td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('dict_name') . ':' . $arReqMsg['title'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['title'] . $form->field("textarea", "arPost[title]",textcodetoform($vars['title']), 2) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('announce') . ':' . $arReqMsg['announce'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['announce'] . $form->field("textarea", "arPost[announce]", textcodetoform($vars['announce']), $oFunc->getFormHeight($vars['announce'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('descr')  . ':' . $arReqMsg['description'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $form->field("textarea", "arPost[description]", textcodetoform($vars['description']), $oFunc->getFormHeight($vars['description'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('keywords') . ':</td>'.
					'<td class="'.$v_class_2.'">' . $form->field("textarea", "arPost[keywords]", textcodetoform($vars['keywords']), $oFunc->getFormHeight($vars['keywords'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('topic')  . ':' . $arReqMsg['id_tp'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['id_tp']
						   . '<select class="input50" name="arPost[id_tp]">'
						   . ctlgGetTopicsRow($ar, 0, 1)
						   . '</select>' .
					'</td>'.
					'</tr>';
		$strForm .= '</table>';
		/* */
		$objCells = new htmlRenderCells();
		$objCells->tClass = '';
		$strForm .= getFormTitleNav($oL->m('sect_visual'), '');
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('default_lang') . ':' . $arReqMsg['lang'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $form->field("select", "arPost[lang]", $vars['lang'], 0, $oL->getLanguages() ) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('themename') . ':' . $arReqMsg['visualtheme'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $form->field("select", "arPost[visualtheme]", $vars['visualtheme'], 0, $gw_this['ar_themes']) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field('checkbox', 'arPost[is_show_az]', $vars['is_show_az']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="arPost_is_show_az_">' . $oL->m('allow_letters') . '</label></td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field('checkbox', 'arPost[is_show_full]', $vars['is_show_full']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="arPost_is_show_full_">' . $oL->m('is_show_full') . '</label></td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field('checkbox', 'arPost[is_show_tooltip_defn]', $vars['is_show_tooltip_defn']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="arPost_is_show_tooltip_defn_">' . $oL->m('1045') . '</label></td>'.
					'</tr>';

		$strForm .= '</tbody></table>';

		$strForm .= getFormTitleNav($oL->m('sect_edit_dict'), '');
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('fields_to_edit') . ':</td>'.
					'<td>';
		/* Construct fields */
		reset($arFields);
		/* term is required by default */
		unset($arFields[1]);
		$arFieldsStr = array();
		for (; list($k, $v) = each($arFields);)
		{
			$fieldname = 'is_'.$v[0];
			$vars[$fieldname] = isset($vars[$fieldname]) ? $vars[$fieldname] : 0;
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle" class="t">'.
							 '<td style="width:2%">' . $form->field('checkbox', 'arPost['.$fieldname.']', $vars[$fieldname]) . '</td>'.
							 '<td style="width:98%"><label for="'.$form->text_field2id('arPost['.$fieldname.']').'">' . $oL->m($v[0]) . '</label></td>'.
							 '</tr>'.
							 '</table>';
		}
		$objCells->X = 2;
		$objCells->Y = 99;
		$objCells->ar = $arFieldsStr;
		$objCells->tClass = 'table-cells';
		$strForm .= $objCells->RenderCells();

		$strForm .= '</td>';
		$strForm .= '</tr>';
		$strForm .= '</tbody></table>';

		/* Search settings */
		$strForm .= getFormTitleNav($oL->m('1056'), '');
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';

		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('min_srch_length') . ':' . $arReqMsg['min_srch_length'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $form->field("select", "arPost[min_srch_length]", $vars['min_srch_length'], 0, $arNums ) . '</td>'.
					'</tr>';

		/* Check for existent stopwords */
		$ar_lang_stopwords = array();
		for (; list($locale_code, $locale_name_origin) = each($tmp['ar_languages']);)
		{
			$arStop = $oL->getCustom('stop_words', $locale_code, 'return');
			if (!empty($arStop))
			{
				$ar_lang_stopwords[$locale_code] = $locale_name_origin;
			}
		}
		$form->setTag('select', 'multiple', 'multiple');
		$form->setTag('select', 'size', '4');
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field("checkbox", "arPost[is_filter_stopwords]", $vars['is_filter_stopwords']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="arPost_is_filter_stopwords_">' . $oL->m('1047') . ':</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td></td>'.
					'<td class="'.$v_class_2.'">' . $form->field('select', 'arPost[ar_filter_stopwords][]', $vars['ar_filter_stopwords'], 0, $ar_lang_stopwords) . '</td>'.
					'</tr>';
/*
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field("checkbox", "arPost[is_filter_specials]", $vars['is_filter_specials']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="arPost_is_filter_specials_">' . $oL->m('1046') . ':</label></td>'.
					'</tr>';
		$ar_special_chars = array('1' => $oL->m('1050'), $oL->m('1051'), $oL->m('1052'), $oL->m('1053'));
		$vars['ar_filter_specials'] = array(1, 2);
		$strForm .= '<tr>'.
					'<td></td>'.
					'<td class="'.$v_class_2.'">' . $form->field('select', 'arPost[ar_filter_specials][]', $vars['ar_filter_specials'], 0, $ar_special_chars) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field("checkbox", 'arPost[is_sens_num]', $vars['is_sens_num']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="'.$form->text_field2id('arPost[is_sens_num]').'">' . $oL->m('1048') . '</label></td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field("checkbox", 'arPost[is_sens_alp]', $vars['is_sens_alp']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="'.$form->text_field2id('arPost[is_sens_alp]').'">' . $oL->m('1054') . '</label></td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field("checkbox", 'arPost[is_sens_chr]', $vars['is_sens_chr']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="'.$form->text_field2id('arPost[is_sens_chr]').'">' . $oL->m('1055') . '</label></td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field("checkbox", 'arPost[is_sens_dia]', $vars['is_sens_dia']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="'.$form->text_field2id('arPost[is_sens_dia]').'">' . $oL->m('1049') . '</label></td>'.
					'</tr>';
*/
		$strForm .= '</tbody></table>';

/*
		$strForm .= getFormTitleNav($oL->m('Addons'), '');
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'"></td>'.
					'<td>';
		$arFieldsStr = array();
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle" class="t">'.
							 '<td style="width:2%">' . $form->field("checkbox", "arPost[is_show_az]", $vars['is_show_az']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_show_az_">' . $oL->m('Enable "Add to favorites"') . '</label></td>'.
							 '</tr>'.
							 '</table>';
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle" class="t">'.
							 '<td style="width:2%">' . $form->field("checkbox", "arPost[is_show_full]", $vars['is_show_full']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_show_full_">' . $oL->m('Enable "Refresh the page"') . '</label></td>'.
							 '</tr>'.
							 '</table>';
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle" class="t">'.
							 '<td style="width:2%">' . $form->field("checkbox", "arPost[is_dict_as_index]", $vars['is_dict_as_index']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_dict_as_index_">' . $oL->m('Enable "Print version"') . '</label></td>'.
							 '</tr>'.
							 '</table>';
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle" class="t">'.
							 '<td style="width:2%">' . $form->field("checkbox", "arPost[is_dict_as_index]", $vars['is_dict_as_index']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_dict_as_index_">' . $oL->m('Enable "Suggest a term"') . '</label></td>'.
							 '</tr>'.
							 '</table>';
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle" class="t">'.
							 '<td style="width:2%">' . $form->field("checkbox", "arPost[is_dict_as_index]", $vars['is_dict_as_index']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_dict_as_index_">' . $oL->m('Enable "Last modifed"') . '</label></td>'.
							 '</tr>'.
							 '</table>';
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle" class="t">'.
							 '<td style="width:2%">' . $form->field("checkbox", "arPost[is_dict_as_index]", $vars['is_dict_as_index']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_dict_as_index_">' . $oL->m('Enable "Created at') . '</label></td>'.
							 '</tr>'.
							 '</table>';
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle" class="t">'.
							 '<td style="width:2%">' . $form->field("checkbox", "arPost[is_dict_as_index]", $vars['is_dict_as_index']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_dict_as_index_">' . $oL->m('Enable "Author"') . '</label></td>'.
							 '</tr>'.
							 '</table>';
		$objCells->X = 2;
		$objCells->Y = 99;
		$objCells->ar = $arFieldsStr;
		$strForm .= $objCells->RenderCells();

		$strForm .= '</td>';
		$strForm .= '</tr>';
		$strForm .= '</table>';
*/

		/* */
		$strForm .= getFormTitleNav($oL->m('sect_system'), '');
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tbody><tr><td style="width:'.$v_td1_width.'"></td><td></td></tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('date_created') . ':</td>'.
					'<td class="'.$v_class_2.'">' . htmlFormSelectDate("arPost[date_created]", date("YmdHis", $vars['date_created'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('date_modif') . ':</td>'.
					'<td class="'.$v_class_2.'">' . htmlFormSelectDate("arPost[date_modif]", date("YmdHis", $vars['date_modified'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('sysname') . ':' . $arReqMsg['tablename'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['tablename'] . $form->field("input", "arPost[tablename]", textcodetoform( $vars['tablename'] ) ) . '</td>'.
					'</tr>';

		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field('checkbox', 'arPost[is_dict_as_index]', $vars['is_dict_as_index']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="arPost_is_dict_as_index_">' . $oL->m('is_dict_as_index') . '</label></td>'.
					'</tr>';
		
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field('checkbox', 'arPost[is_leech]', $vars['is_leech']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="'.$form->text_field2id('arPost[is_leech]').'">' . $oL->m('allow_leecher') . '</label></td>'.
					'</tr>';

/*
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle" class="t">'.
							 '<td style="width:2%">' . $form->field("checkbox", "arPost[is_htmled]", $vars['is_htmled']) . '</td>'.
							 '<td style="width:98%"><label for="'.$form->text_field2id('arPost[is_htmled]').'">' . $oL->m('allow_htmleditor') . '</label></td>'.
							 '</tr>'.
							 '</table>';
*/
		}
		else
		{

		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('dict_name') . ':</td>'.
					'<td class="'.$trDisabled.'">' . textcodetoform($vars['title']) . '&#160;</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('announce') . ':</td>'.
					'<td class="'.$trDisabled.'">' . textcodetoform($vars['announce']) . '&#160;</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('descr')  . ':</td>'.
					'<td class="'.$trDisabled.'">' . textcodetoform($vars['description']) . '&#160;</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('keywords') . ':</td>'.
					'<td class="'.$trDisabled.'">' . textcodetoform($vars['keywords']) . '&#160;</td>'.
					'</tr>';

		}
		$strForm .= '</tbody></table>';

		$strForm .= $form->field('hidden', 'arPost[tablename_old]', $vars['tablename']);
		$strForm .= $form->field('hidden', 'id', $id);
		$strForm .= $form->field('hidden', GW_ACTION, UPDATE);
		$strForm .= $form->field('hidden', GW_TARGET, GW_T_DICT);
	}
	$strForm .= $form->field('hidden', GW_SID, ${GW_SID});
	return $form->Output($strForm);
}
// --------------------------------------------------------
// Check permission
#if ($auth->is_allow('dict', $id) || ( isset($arDictParam['id_user']) && $arDictParam['id_user'] == $user->id) )
#{
// --------------------------------------------------------
// action switcher
switch (${GW_ACTION})
{
case GW_A_ADD:
## --------------------------------------------------------
## Add a dictionary
	if (empty($post)) // not submited
	{
		$tid                = 0; // global value for topic list
		$vars['title']      = $vars['description'] = $vars['announce'] = "";
		$vars['tablename']  = $sys['tbl_prefix'].kMakeUid('x', 8);
		$vars['id_tp']      = $tid;
		$vars['lang']       = $oL->getLocale();
		$vars['visualtheme'] = 'gw_silver';
		$vars['keywords']   = '';
		$vars['is_active']  = 0;
		$vars['min_srch_length'] = '2';

		$strR .= getFormDict($vars, 0, 0, $arReq[$t]);
		$arHelpMap = array(
					'dict_name'  => 'tip010',
#					'announce'   => 'tip009',
					'descr'      => 'tip008',
#					'keywords'   => 'tip007',
					'topic'      => 'tip006',
					'lang_source'=> 'tip005',
					'themename'  => 'tip004',
					'sysname'    => 'tip003'
				 );
		$strHelp = '';
		$strHelp .= '<dl>';
		for(; list($k, $v) = each($arHelpMap);)
		{
			$strHelp .= '<dt><b>' . $oL->m($k) . '</b></dt>';
			$strHelp .= '<dd>' . $oL->m($v) . '</dd>';
		}
		$strHelp .= '</dl>';
		$strR .= '<br />'.kTbHelp($oL->m('2_tip'), $strHelp);
	}
	else
	{
		$arBroken = validatePostWalk($arPost, $arReq[$t]);
		$arPost['is_active'] = isset($arPost['is_active']) ? $arPost['is_active'] : 0;
		if (sizeof($arBroken) == 0)
		{
			$isPostError = 0;
		}
		else
		{
			$tid = $arPost['id_tp'];
			$strR .= getFormDict($arPost, 1, $arBroken, $arReq[$t]);
		}
		if (!$isPostError)
		{
#			$sys['isDebugQ'] = 1;
			/* Fix on/off options */
			$arIsV = array('is_active','is_show_az','is_auth','is_post');
			for (reset($arFields); list($k, $v) = each($arFields);)
			{
				$arIsV[] = 'is_'.$v[0];
			}
			for (; list($k, $v) = each($arIsV);)
			{
				$arPost[$v]  = isset($arPost[$v]) ? $arPost[$v] : 0;
			}
			/* Fixes for databse name */
			$arPost['tablename'] = preg_replace("/![0-9a-zA-Z]/", "", $arPost['tablename']);
			$arPost['tablename'] = str_replace('-', '_', $arPost['tablename']);
			/* */
			$q = $q3 = array();
			/* Default dictionary settings */
			$arDictNewSettings = array(
				'min_srch_length' => $arPost['min_srch_length'],
				'is_trsp' => '0',
				'is_trns' => '1',
				'is_abbr' => '1',
				'is_defn' => '1',
				'is_usg' => '0',
				'is_src' => '1',
				'is_syn' => '1',
				'is_see' => '1',
				'is_phone' => '0',
				'is_address' => '0',
				'is_show_full' => '0',
				'is_dict_as_index' => '0',
				'is_show_tooltip_defn' => '0',
				'is_filter_specials' => 1,
				'is_filter_stopwords' => 1,
				'is_leech' => 0,
				'is_show_az' => 1,
				'is_sens_num' => 1,
				'is_sens_alp' => 1,
				'is_sens_chr' => 1,
				'is_sens_dia' => 0,
				'ar_filter_stopwords' => array(),
			);
			$q['dict_settings'] = serialize($arDictNewSettings);
			$q['id_tp']         = $arPost['id_tp'];
			$q['is_active']     = $arPost['is_active'];
			$q['lang']          = $arPost['lang'];
			$q['visualtheme']   = $arPost['visualtheme'];
			$q['tablename']     = $arPost['tablename'];
			$q['title']         = $arPost['title'];
			$q['announce']      = '';
			$q['keywords']      = '';
			$q['description']   = $arPost['description'];
			$q['date_created']  = $q['date_modified'] = gmmktime();
			$q['id_user']       = $oSess->id_user;
			/* Create tables */
			$queryA[] = $oSqlQ->getQ('create-dict', $q['tablename']);
			$q['id'] = $q3['dict_id'] = $oDb->MaxId(TBL_DICT);
			$queryA[] = gw_sql_insert($q, TBL_DICT);
			$q = array();
			$q['hits'] = 0;
			$q['id'] = $q3['dict_id'];
			$queryA[] = gw_sql_insert($q, TBL_STAT_DICT);
			/* TODO: fix user_id / user_id */
			$q3['user_id'] = $oSess->user_get('id_user');
			$queryA[] = gw_sql_insert($q3, TBL_MAP_USER_DICT);
			/* Add Dictionary ID to the list of assigned dictionairies */
			$ar_user_dict = $oSess->user_get('dictionaries');
			$ar_user_dict[$q3['dict_id']] = 1;
			$oSess->user_set('dictionaries', $ar_user_dict);
			/* */
			$strR .= postQuery($queryA, GW_ACTION . '=' . GW_A_EDIT . '&' . GW_TARGET . '=' . GW_T_DICT . '&id='.$q['id'], $sys['isDebugQ'], 0);
		}
	}
##
## --------------------------------------------------------
break;
case BRWS:
## --------------------------------------------------------
## Browse dictionaires
	/* Check permissions */
	if (!$oSess->is('dict_view'))
	{
		$strR .= $oL->m('reason_13');
		return;
	}
	$strR .= getDictList($tid);
##
## --------------------------------------------------------
break;
case GW_A_EDIT:
## --------------------------------------------------------
## Edit selected dictionary
	if ($gw_this['vars']['id'] == '')
	{
		gwtk_header($sys['server_proto'].$sys['server_host'].$sys['page_admin']);
	}
	// settings can be changed only by admin or dictionary owner
#	if (($post == '') && ( $auth->have_perm('admin', PERMLEVEL) || ($arDictParam['id_user'] == $user->id) ))
	if ($gw_this['vars']['post'] == '')
	{
		/* > 1.6.3 */
#		if (!isset($arDictParam['is_show_full'])) { $arDictParam['is_show_full'] = 0; }
#		if (!isset($arDictParam['is_dict_as_index'])) { $arDictParam['is_dict_as_index'] = 0; }
		/* > 1.7.0 */
#		if (!isset($arDictParam['is_show_tooltip_defn'])) { $arDictParam['is_show_tooltip_defn'] = 0; }
#		if (!isset($arDictParam['is_filter_stopwords'])) { $arDictParam['is_filter_stopwords'] = 0; }
#		if (!isset($arDictParam['is_filter_specials'])) { $arDictParam['is_filter_specials'] = 0; }
#		if (!isset($arDictParam['is_sens_num'])) { $arDictParam['is_sens_num'] = 1; }
#		if (!isset($arDictParam['is_sens_alp'])) { $arDictParam['is_sens_alp'] = 1; }
#		if (!isset($arDictParam['is_sens_chr'])) { $arDictParam['is_sens_chr'] = 1; }
#		if (!isset($arDictParam['is_sens_dia'])) { $arDictParam['is_sens_dia'] = 0; }

		$tid = $arDictParam['id_tp']; /* global */
		$strR .= getFormDict($arDictParam, 0, 0, $arReq[$t]);
	}
##
## --------------------------------------------------------
break;
case GW_A_REMOVE:
## --------------------------------------------------------
## Remove selected dictionary
	if (!isset($id) || (!$oSess->is('dict_edit')) )
	{
		$strR .= $oL->m('reason_13');
		return;
	}

	if ($isConfirm != "1") // if not confirmed
	{
		$Confirm = new gwConfirmWindow;
		$Confirm->action           = $sys['page_admin'];
		$Confirm->submitok         = $oL->m('3_remove');
		$Confirm->submitcancel     = $oL->m('3_cancel');
		$Confirm->formbgcolor      = $GLOBALS['theme']['color_2'];
		$Confirm->formbordercolor  = $GLOBALS['theme']['color_4'];
		$Confirm->formbordercolorL = $GLOBALS['theme']['color_1'];
		$Confirm->css_align_right  = $sys['css_align_right'];
		$Confirm->css_align_left   = $sys['css_align_left'];
		$Confirm->setQuestion('<p class="r"><span class="s"><b>'.  $oL->m('9_remove') .
									'</b></span></p><p class="t"><span class="f">' . $oL->m('3_'.${GW_ACTION}) .
									':</span><br/>'.$arDictParam['title'].'</p>');
		$Confirm->tAlign = "center";
		$Confirm->formwidth = "400";
		$Confirm->setField("hidden", GW_ACTION, GW_A_REMOVE);
		$Confirm->setField("hidden", GW_TARGET, ${GW_TARGET});
		$Confirm->setField("hidden", GW_SID, ${GW_SID});
		$Confirm->setField("hidden", "id", $id);
		$strR .= $Confirm->Form();
	}
	else // after confirm
	{
		$queryA[] = $oSqlQ->getQ('del-wordmap-by-dict', $id);
		$queryA[] = $oSqlQ->getQ('del-by-dict_id', TBL_MAP_USER_DICT, $id);
		$queryA[] = $oSqlQ->getQ('del-by-dict_id', TBL_MAP_USER_TERM, $id);
		$queryA[] = $oSqlQ->getQ('del-by-id', TBL_DICT, $id);
		$queryA[] = $oSqlQ->getQ('del-by-id', TBL_STAT_DICT, $id);
		$queryA[] = $oSqlQ->getQ('drop-table', $arDictParam['tablename']);
		$strR .= gw_tmp_clear($id);
		$strR .= postQuery($queryA, GW_ACTION . '=' . BRWS . '&' . GW_TARGET . '=' . GW_T_DICT, $sys['isDebugQ'], 0);
	}
##
## --------------------------------------------------------
break;
case CLEAN:
## --------------------------------------------------------
## Clean selected dictionary (todo: optimize with GW_A_REMOVE)
	if (!isset($id) || (!$oSess->is('dict_edit')) )
	{
		$strR .= $oL->m('reason_13');
	}
	elseif ($isConfirm != '1')
	{
		/* Not confirmed */
		$Confirm = new gwConfirmWindow;
		$Confirm->action           = $sys['page_admin'];
		$Confirm->submitok         = $oL->m('3_'.${GW_ACTION});
		$Confirm->submitcancel     = $oL->m('3_cancel');
		$Confirm->formbgcolor      = $GLOBALS['theme']['color_2'];
		$Confirm->formbordercolor  = $GLOBALS['theme']['color_4'];
		$Confirm->formbordercolorL = $GLOBALS['theme']['color_1'];
		$Confirm->css_align_right  = $sys['css_align_right'];
		$Confirm->css_align_left   = $sys['css_align_left'];

		$Confirm->setQuestion('<p class="r"><span class="s"><b>'.  $oL->m('9_remove') .
									'</b></span></p><p class="t"><span class="f">' . $oL->m('3_'.${GW_ACTION}) .
									':</span><br/>'.$arDictParam['title'].'</p>');
		$Confirm->tAlign = "center";
		$Confirm->formwidth = "400";
		$Confirm->setField("hidden", GW_ACTION, CLEAN);
		$Confirm->setField("hidden", GW_TARGET, ${GW_TARGET});
		$Confirm->setField("hidden", "id", $id);
		$Confirm->setField("hidden", GW_SID, ${GW_SID});
		$strR .= $Confirm->Form();
	}
	elseif ($isConfirm) // after confirm
	{
		$queryA = array();
		$q = array();
		$queryA[] = $oSqlQ->getQ('del-table', $arDictParam['tablename']);
		$queryA[] = $oSqlQ->getQ('del-wordmap-by-dict', $id);
		$q['int_terms'] = 0;
		$queryA[] = gw_sql_update($q, TBL_DICT, "id='$id'");
		$strR .= gw_tmp_clear($id);
		/* Redirect to... */
		$arPost['after'] = GW_AFTER_DICT_UPDATE;
		$str_url = gw_after_redirect_url($arPost['after']);
		$strR .= postQuery($queryA, $str_url, $sys['isDebugQ'], 1);
	}
##
## --------------------------------------------------------
break;
case UPDATE:
## --------------------------------------------------------
## Update dictionary
		if(isset($arReq[$t])) // check for broken fields
		{
			$arBroken = validatePostWalk($arPost, $arReq[$t]);
		}
		if (isset($arPost['date_modifS'])) // fix date
		{
			$arPost['date_createdS'] = str_replace(":", "", $arPost['date_createdS']);
			if(!preg_match("/[0-9]{6}/", $arPost['date_createdS'] )) { $arPost['date_createdS'] = '000000'; }
		}
		if (isset($arPost['date_modifS'])) // fix date
		{
			$arPost['date_modifS'] = str_replace(":", "", $arPost['date_modifS']);
			if(!preg_match("/[0-9]{6}/", $arPost['date_modifS'] )) { $arPost['date_modifS'] = '000000'; }
		}
		//
		// Fix on/off options
		$arIsV = array('is_active','is_show_az','is_auth','is_post','is_leech','is_htmled');
		for (reset($arFields); list($k, $v) = each($arFields);)
		{
			$arIsV[] = 'is_'.$v[0];
		}
		for (; list($k, $v) = each($arIsV);)
		{
			$arPost[$v]  = isset($arPost[$v]) ? $arPost[$v] : 0;
		}
		/* */
		if (isset($arReq[$t]) && sizeof($arBroken) == 0) // no errors
		{
			$isPostError = 0;
		}
		else // on error
		{
			// should never happened, fixed for empty values in $arReq[$t]
			if(!isset($arReq[$t])) { $arReq[$t] = $arBroken = array_keys($arPost); }
			$isPostError = 1;
			// read posted variables, call HTML-form again.
			$arPost['user_name']    = $arDictParam['user_name'];
			$arPost['tablename']    = $arDictParam['tablename'];
			$arPost['int_terms']    = $arDictParam['int_terms'];

			$arPost['date_created'] = $arPost['date_createdY'].$arPost['date_createdM'].$arPost['date_createdD'].$arPost['date_createdS'];
			$arPost['date_modified']= $arPost['date_modifY'].$arPost['date_modifM'].$arPost['date_modifD'].$arPost['date_modifS'];

			$strR .= getFormDict($arPost, 1, $arBroken, $arReq[$t]);
		}
		if (!$isPostError) // final update
		{
			$queryA = array();
#			$sys['isDebugQ'] = 1;

			$arDictNewSettings = array(
				'min_srch_length' => $arPost['min_srch_length'],
				'ar_filter_stopwords' => isset($arPost['ar_filter_stopwords']) ? array_flip($arPost['ar_filter_stopwords']) : array(),
				'ar_filter_specials' => isset($arPost['ar_filter_specials']) ? array_flip($arPost['ar_filter_specials']) : array()
			);
			$arOnOff = array('is_trsp', 'is_trns', 'is_abbr', 'is_defn', 'is_usg', 'is_src', 'is_syn',
							'is_see', 'is_phone', 'is_address', 'is_show_full', 'is_dict_as_index',
							'is_show_tooltip_defn', 'is_filter_specials', 'is_filter_stopwords',
							'is_show_az', 'is_leech', 'is_sens_num', 'is_sens_alp', 'is_sens_chr',
							'is_sens_dia'
						);
			for (; list($k, $v) = each($arOnOff);)
			{
				$arDictNewSettings[$v] = isset($arPost[$v]) ? $arPost[$v] : 0;
			}
			$q['dict_settings'] = serialize($arDictNewSettings);
			/* */
			$q['id_tp']         = sprintf("%d",$arPost['id_tp']);
			$q['is_active']     = isset($arPost['is_active']) ? $arPost['is_active'] : 0;

			$q['lang']          = $arPost['lang'];
			$q['visualtheme']     = $arPost['visualtheme'];
			$q['title']         = $arPost['title'];
			$q['announce']      = $arPost['announce'];
			$q['keywords']      = $arPost['keywords'];
			$q['description']   = $arPost['description'];
			if (($arPost['tablename_old'] != $arPost['tablename'])
			    && !getTableInfo($arPost['tablename']))
			{
				/* Database table name changed */
				$q['tablename']   = $arPost['tablename'];
				$queryA[] = $oSqlQ->getQ('rename-tbl', $arPost['tablename_old'], $arPost['tablename']);
			}
			$tmp['ar_created_his'] = str_split($arPost['date_createdS'], 2);
			$tmp['ar_modified_his'] = str_split($arPost['date_modifS'], 2);
			/* hour, minute, second, month, day, year  */
			$q['date_created']  = gmmktime($tmp['ar_created_his'][0], $tmp['ar_created_his'][1], $tmp['ar_created_his'][2],
								$arPost['date_createdM'], $arPost['date_createdD'], $arPost['date_createdY']);
			$q['date_modified']  = gmmktime($tmp['ar_modified_his'][0], $tmp['ar_modified_his'][1], $tmp['ar_modified_his'][2],
								$arPost['date_modifM'], $arPost['date_modifD'], $arPost['date_modifY']);
			/* Save dictionary settings */
			$queryA[] = gw_sql_update($q, TBL_DICT, 'id = "'.$id.'"');

			/* Clear cache */
			$strR .= gw_tmp_clear($id);
			/* Optimization for previous (not current) modifications */
			gw_sys_dict_check($arDictParam['tablename']);
			gw_sys_dict_check(TBL_MAP_USER_TERM);
			/* Redirect to... */
			$arPost['after'] = GW_AFTER_DICT_UPDATE;
			$str_url = gw_after_redirect_url($arPost['after']);
			$strR .= postQuery($queryA, $str_url, $sys['isDebugQ'], 0);
		}

##
## --------------------------------------------------------
break;
case IMPORT:
## --------------------------------------------------------
## Import dictionary, External
	$pathImport = $sys['path_include'] . '/' . GW_ACTION . '.' . ${GW_ACTION} . '.inc.' . $sys['phpEx'];
	file_exists($pathImport)
	? include_once($pathImport)
	: printf($GLOBALS['oL']->m("reason_10"), $pathImport);
##
## --------------------------------------------------------
break;
case EXPORT:
## --------------------------------------------------------
## Export dictionary, External
	$pathExport = $sys['path_include'] . '/' . GW_ACTION . '.' . ${GW_ACTION} . '.inc.' . $sys['phpEx'];
	file_exists($pathExport)
	? include_once($pathExport)
	: printf($GLOBALS['oL']->m("reason_10"), $pathImport);
##
## --------------------------------------------------------
break;
default:
break;
} // end of switch
// --------------------------------------------------------
// End check permission
#}
#else
#{
#	$strR .= $oL->m('reason_13');
#}
/* End of file */
?>