<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: t.page.inc.php,v 1.3 2005/06/08 14:00:48 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2005 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Actions for a custom pages. Add, Browse, Edit, Remove, Update.
 *
 */
// --------------------------------------------------------
/**
 * HTML-form for page
 *
 * @param    array   $vars       posted variables
 * @param    int     $runtime    is this form posted first time [ 0 - no | 1 - yes ] // todo: bolean
 * @param    array   $arBroken   the names of broken fields (after post)
 * @param    array   $arReq      the names of required fields (after post)
 * @return   string  complete HTML-code
 * @see array_walk(), ctlgGetTopicsRow()
 */
function getFormCustomPage($vars, $runtime = 0, $arBroken = array(), $arReq = array())
{
	global ${GW_ACTION}, $tid, $oL, ${GW_SID}, $sys, $oFunc;
	global $oDb, $oSqlQ;
	$strForm = '';
	$trClass = 't';
	$v_class_1 = 'td1';
	$v_class_2 = 'td2';
	$v_td1_width = '20%';
	$trDisabled = 'disabled';
	$form = new gwForms();

	$form->Set('submitdel', $oL->m('3_remove'));
	$form->Set('action', $sys['page_admin']);
	$form->Set('submitok', $oL->m('3_save'));
	$form->Set('submitcancel', $oL->m('3_cancel'));
	$form->Set('formbgcolor', $GLOBALS['theme']['color_2']);
	$form->Set('formbordercolor', $GLOBALS['theme']['color_4']);
	$form->Set('formbordercolorL', $GLOBALS['theme']['color_1']);
	$form->Set('align_buttons', $GLOBALS['sys']['css_align_right']);
	$form->Set('charset', $sys['internal_encoding']);

	## ----------------------------------------------------
	##
	// check vars
	// reverse array keys <-- values;
	$arReq = array_flip($arReq);
	// mark fields as "REQUIRED" and make error messages
	while (is_array($vars) && list($key, $val) = each($vars) )
	{
		$arReqMsg[$key] = $arBrokenMsg[$key] = "";
		if (isset($arReq[$key])) { $arReqMsg[$key] = ' <span class="red"><b>*</b></span>'; }
		if (isset($arBroken[$key])) { $arBrokenMsg[$key] = ' <span class="red" style="font: 70% verdana"><b>' . $oL->m('reason_9') .'</b></span>'; }
	} // end of while
	##
	## ----------------------------------------------------
	$form->setTag('select', 'class',  'input50');

	$fieldname = 'page';
	$int_custom_pages = sizeof($vars['page']);
	for (; list($elK, $arV) = each($vars['page']);)
	{
		$tmp['strBtnRemove'] = '';
		$tmp['strBtnAdd'] = '<input tabindex="7" type="submit" style="width:24px;height:24px" class="submitcancel" name="'.
							'arControl['.$fieldname.']['.GW_A_ADD.']['.$elK.'][0]" title="'.
							$oL->m('3_add').'" value="+"/>';
		if ( $int_custom_pages > 1 )
		{
			$tmp['strBtnRemove'] = '<input tabindex="8" type="submit" style="width:24px;height:24px" class="submitdel" name="'.
								   'arControl['.$fieldname.']['.GW_A_REMOVE.']['.$elK.'][0]" title="'.
								   $oL->m('3_remove').'" value="&#215;"/>';
		}
		$tmp['strHtmlTB'] = $tmp['strBtnRemove'] . $tmp['strBtnAdd'];

		$strForm .= getFormTitleNav($oL->m('1061'), $tmp['strHtmlTB']);

		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td>';
		$strForm .= $form->field('hidden', 'arPre[page]['.$elK.'][id_page_phrase]', $arV['id_page_phrase']);
		$strForm .= $form->field('hidden', 'arPre[page]['.$elK.'][id_lang]', $arV['id_lang']);
		$strForm .= '</td></tr><tbody>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('dict_name') . ':</td>'.
					'<td class="'.$v_class_2.'">' . $form->field('input', 'arPre[page]['.$elK.'][page_title]', textcodetoform($arV['page_title'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('announce') . ':</td>'.
					'<td class="'.$v_class_2.'">' . $form->field('textarea', 'arPre[page]['.$elK.'][page_descr]', textcodetoform($arV['page_descr']), $oFunc->getFormHeight($arV['page_descr'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('1058') . ':</td>'.
					'<td class="'.$v_class_2.'">' . $form->field('textarea', 'arPre[page]['.$elK.'][page_content]', textcodetoform($arV['page_content']), $oFunc->getFormHeight($arV['page_content'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('lang') . ':</td>'.
					'<td class="'.$v_class_2.'">' . $form->field('select', 'arPre[page]['.$elK.'][id_lang]', $arV['id_lang'], 0, $oL->getLanguages(), '', 'input50' ) . '</td>'.
					'</tr>';
		$strForm .= '</tbody></table>';
	}

	$strForm .= getFormTitleNav($oL->m('sect_general'), '');
	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $form->field('checkbox', 'arPre[is_active]', $vars['is_active']) . '</td>'.
				'<td class="'.$v_class_2.'">' . '<label for="'.$form->text_field2id('arPre[is_active]').'">'.$oL->m('1057').'</label></td>'.
				'</tr>';

	global $topic_mode;
	$topic_mode = 'form';
	if (${GW_ACTION} == GW_A_ADD) /* adding a topic */
	{
	  		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('3_undertopic') . ':</td>'.
					'<td class="'.$v_class_2.'">'
						   . '<select name="arPre[id_parent]" class="input50">'
						   . '<option value="0">'. $oL->m('root_topic') .'</option>'
						   . gw_get_thread_pages($vars['ar'], 0, 1)
						   . '</select>' .
					'</td>'.
					'</tr>';
	}
	else
	{
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('3_undertopic') . ':</td>'.
					'<td class="'.$v_class_2.'">'
						   . '<select name="arPre[id_parent]"  class="input50">'
						   . '<option value="0">'. $oL->m('root_topic') .'</option>'
						   . gw_get_thread_pages($vars['ar'], 0, 1)
						   . '</select>' .
					'</td>'.
					'</tr>';
	}

	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('1060') . ':</td>'.
				'<td class="'.$v_class_2.'">' . $sys['server_dir'].'/'.$sys['path_tpl'].'/'.$sys['visualtheme'].'/<br />' . $form->field('input', 'arPre[page_icon]', textcodetoform($vars['page_icon'])) . '</td>'.
				'</tr>';
	
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('1073') . ':</td>'.
				'<td class="'.$v_class_2.'">' .  $sys['server_dir'].'/'. GW_A_CUSTOMPAGE. '/<br />'.$form->field('input', 'arPre[page_uri]', textcodetoform($vars['page_uri'])) . '</td>'.
				'</tr>';
	
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('1059') . ' 1:</td>'.
				'<td class="'.$v_class_2.'">&lt;?'.'php' . $form->field('textarea', 'arPre[page_php_1]', textcodetoform($vars['page_php_1']), $oFunc->getFormHeight($vars['page_php_1'])) . '<br />?&gt;</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('1059') . ' 2:</td>'.
				'<td class="'.$v_class_2.'">&lt;?'.'php' . $form->field('textarea', 'arPre[page_php_2]', textcodetoform($vars['page_php_2']), $oFunc->getFormHeight($vars['page_php_2'])) . '<br />?&gt;</td>'.
				'</tr>';

	$strForm .= '</tbody></table>';


	if (${GW_ACTION} == GW_A_ADD)
	{
		/* adding a custom page */
		$strForm .= $form->field('hidden', GW_ACTION, GW_A_ADD);
	}
	else
	{
		/* updating */
		$strForm .= $form->field('hidden', 'tid', $tid);
		$strForm .= $form->field('hidden', GW_ACTION, GW_A_EDIT);
	}
	$strForm .= $form->field("hidden", GW_TARGET, GW_T_CUSTOMPAGE);
	$strForm .= $form->field("hidden", GW_SID, ${GW_SID});
	return $form->Output($strForm);
} // end of getFormTopic();

// --------------------------------------------------------
$arReq = array();

// --------------------------------------------------------
// action switcher
switch (${GW_ACTION})
{
case GW_A_ADD:
## --------------------------------------------------------
## Add a custom page
	/* Check permissions */
	if (!$oSess->is('sys_settings'))
	{
		$strR .= $oL->m('reason_13');
		return;
	}
	/* Create the list of subpages */
	$arSqlc = $oDb->sqlExec($oSqlQ->getQ('get-subpages-list', '', 0));
	$arSqlc = gw_rearrange_custompages($arSqlc);
	$arSqlc = gw_create_tree_custompages($arSqlc);

	if ($post == '')
	{
		/* set default values */
		$arLanguages = $oL->getLanguages();
		$cnt = 0;
		for (; list($id_lang, $arV) = each($arLanguages);)
		{
			$arParsed['page'][$cnt]['id_page_phrase'] = '';
			$arParsed['page'][$cnt]['page_title'] = '';
			$arParsed['page'][$cnt]['page_descr'] = '';
			$arParsed['page'][$cnt]['page_content'] = '';
			$arParsed['page'][$cnt]['id_lang'] = $id_lang;
			$cnt++;
		}
		$arParsed['is_active'] = 1;
		$arParsed['id_parent'] = 0;
		$arParsed['page_icon'] = '';
		$arParsed['page_uri'] = '';
		$arParsed['page_php_1'] = '';
		$arParsed['page_php_2'] = '';
		$arParsed['ar'] = $arSqlc;
		/* additional actions */
		if (is_array($arPre))
		{
			$is_first = 0;
			$arParsed = gw_ParsePre($arParsed, $arPre);
		}
		$arBroken = array();
		$strR .= getFormCustomPage($arParsed, 0, $arBroken, $arReq);
		/* Editing tips */
		$arHelpMap = array(
				'dict_name'  => 'tip028',
				'announce' => 'tip029',
				'1058'  => 'tip030',
				'1073'  => 'tip031',
				'1059'  => 'tip032'
		);
		$strHelp = '';
		$strHelp .= '<dl>';
		for (; list($k, $v) = each($arHelpMap);)
		{
			$strHelp .= '<dt><b>' . $oL->m($k) . '</b></dt>';
			$strHelp .= '<dd>' . $oL->m($v) . '</dd>';
		}
		$strHelp .= '</dl>';
		$strR .= '<br />'.kTbHelp($oL->m('2_tip'), $strHelp);
		
	}
	else
	{
		$isPostError = 0;
		/* parse posted values */
		if (!$isPostError)
		{
			/* Fix on/off options */
			$arIsV = array('is_active');
			for (; list($k, $v) = each($arIsV);)
			{
				$arPost[$v]  = isset($arPre[$v]) ? $arPre[$v] : 0;
			}
			/* final update */
#			$sys['isDebugQ'] = 1;
			$id_page_phrase = $oDb->MaxId(TBL_CUSTOMPAGES_PH, 'id_page_phrase');

			$q1 = $q2 = array();
			$q1['id_page'] = $q2['id_page'] = $oDb->MaxId(TBL_CUSTOMPAGES, 'id_page');
			$q1['id_parent'] = $arPre['id_parent'];
			$q1['is_active'] = $arPre['is_active'];
			$q1['page_icon'] = $arPre['page_icon'];

			$q1['page_uri'] = $arPre['page_uri'];
			$q1['page_php_1'] = $arPre['page_php_1'];
			$q1['page_php_2'] = $arPre['page_php_2'];
			$q1['date_modified'] = $q1['date_created'] = gmmktime();
			/* */
			for (; list($elK, $arV) = each($arPre['page']);)
			{
				$q2['page_title'] = $arV['page_title'];
				$q2['page_descr'] = $arV['page_descr'];
				$q2['page_content'] = $arV['page_content'];
				$q2['id_lang'] = $arV['id_lang'];
				$q2['id_page_phrase'] = ($arV['id_page_phrase'] == '') ? $id_page_phrase + $elK : $arV['id_page_phrase'];
				$queryA[] = gw_sql_insert($q2, TBL_CUSTOMPAGES_PH, 'id_page_phrase = "' . $arV['id_page_phrase'] .'"');
			}
			$sql = gw_sql_insert($q1, TBL_CUSTOMPAGES, 'id_page = "' . $tid.'"');
			if ($sys['isDebugQ'])
			{
				$queryA[] = $sql;
			}
			else
			{
				/* Insert now */
				$oDb->sqlExec($sql);
			}
			/* Sorting */
			$sql = sprintf('SELECT id_page FROM '.TBL_CUSTOMPAGES.' ORDER BY int_sort ASC');
			$arSql = $oDb->sqlExec($sql);
			$i = 10;
			for (; list($arK, $arV) = each($arSql);)
			{
				$queryA[] = "UPDATE " . TBL_CUSTOMPAGES . "
							 SET int_sort = " . $i . "
							 WHERE id_page = " . $arV['id_page'];
					$i += 10;
			}
			$strR .= postQuery($queryA, 'a=' . BRWS . '&'.GW_TARGET.'='.GW_T_CUSTOMPAGE, $sys['isDebugQ'], 0);

		} /* $isPostError */
	}
##
## --------------------------------------------------------
break;
case BRWS:
## --------------------------------------------------------
## Browse custom pages

	$strR .= '<table style="background:'.$GLOBALS['theme']['color_4'].'" cellspacing="1" cellpadding="0" border="0" width="100%">';
	$strR .= '<thead><tr style="text-align:center;height:20px;color:'.$GLOBALS['theme']['color_1'].';background:'.$GLOBALS['theme']['color_6'].'">';
	$strR .= '<th style="width:1%" class="gw">N</th>';
	$strR .= '<th class="gw">' . $oL->m('page') . '</th>';
	$strR .= '<th style="width:20%" class="gw">' . $oL->m('order') . '</th>';
	$strR .= '<th style="width:32%" class="gw">' . $oL->m('action') . '</th>';
	$strR .= '<th style="width:5%" class="gw">' . $oL->m('status') . '</th>';
	$strR .= '</tr></thead><tbody>';

	$arSql = $oDb->sqlExec($oSqlQ->getQ('get-pages-edit'), '', 0);
	$arSql3 = gw_rearrange_custompages($arSql);
	$arSql3 = gw_create_tree_custompages($arSql3);
	$topic_mode = 'html';
	$strR .= gw_get_thread_pages($arSql3);

/*
		$isDn = $isUp = 1;
		$isReset = 0;
		if ($cnt == 0) { $isUp = 0; $isReset = 1; }
		if ($cnt == $int_size-1) { $isDn = 0; }
		if (!$isUp && !$isDn) { $isReset = 0; }

		$cnt % 2 ? ($bgcolor = $GLOBALS['theme']['color_2']) : ($bgcolor = $GLOBALS['theme']['color_1']);
		$cnt++;
		$strR .= '<tr class="t f" style="background:'.$bgcolor.'">';
		$strR .= '<td>'. $cnt . '.</td>';
		$strR .= '<td>'. $oHtml->a( $sys['page_admin'] . '?' . GW_TARGET . '='.GW_T_CUSTOMPAGE . '&' .  GW_ACTION . '=' . GW_A_EDIT . '&tid='. $arV['id_page'],
						$arV['page_title'] ). '</td>';
		$strR .= '<td>[';
		$strR .= ($isUp && $is_allow_page) ? $oHtml->a( $sys['page_admin'] . '?'.GW_ACTION.'='.UPDATE.'&'.GW_TARGET.'='.GW_T_CUSTOMPAGE.'&mode=up&tid=' . $arV['id_page'], $oL->m('3_up')) : $oL->m('3_up');
		$strR .= '] [';
		$strR .= ($isDn && $is_allow_page) ? $oHtml->a( $sys['page_admin'] . '?'.GW_ACTION.'='.UPDATE.'&'.GW_TARGET.'='.GW_T_CUSTOMPAGE.'&mode=dn&tid=' . $arV['id_page'], $oL->m('3_down')) : $oL->m('3_down');
		$strR .= '] [';
		$strR .= ($isReset && $is_allow_page) ? $oHtml->a( $sys['page_admin'] . '?'.GW_ACTION.'='.UPDATE.'&'.GW_TARGET.'='.GW_T_CUSTOMPAGE.'&mode=reset&tid=' . $arV['id_page'], $oL->m('3_reset')) : $oL->m('3_reset');
		$strR .= ']</td>';
		$strR .= '<td>[ '. $oHtml->a( $sys['page_admin'] . '?' . GW_TARGET . '='.GW_T_CUSTOMPAGE . '&' .  GW_ACTION . '=' . GW_A_EDIT . '&tid='. $arV['id_page'],
						$oL->m('3_edit') ). ' ] '.
					'[ '. $oHtml->a( $sys['page_admin'] . '?' . GW_TARGET . '='.GW_T_CUSTOMPAGE . '&' .  GW_ACTION . '=' . GW_A_REMOVE. '&tid='. $arV['id_page'],
						$oL->m('3_remove') ). ' ]</td>';
		$strR .= '<td>'. ($arV['is_active'] ? '<span class="green">'.$oL->m('is_1').'</span>' : '') . '</td>';
		$strR .= '</tr>';
	}
*/
	$strR .= '</tbody></table>';
	$strR .= '<br />';
##
## --------------------------------------------------------
break;
case GW_A_EDIT:
## --------------------------------------------------------
## Edit a custom page
	/* Check permissions */
	if (!$oSess->is('sys_settings'))
	{
		$strR .= $oL->m('reason_13');
		break;
	}
	if ($tid == '')
	{
		gwtk_header($sys['server_proto'].$sys['server_host'].$sys['page_admin']);
	}

	/* Create the list of subpages */
	$arSqlc = $oDb->sqlExec($oSqlQ->getQ('get-subpages-list', '', 0));
	$arSqlc = gw_rearrange_custompages($arSqlc);
	$arSqlc = gw_create_tree_custompages($arSqlc);

	/* */
	if ($post == '')
	{
		/* Not saved */
		$arSql = $oDb->sqlExec($oSqlQ->getQ('get-custompages-adm', $tid), 'page');
		$arParsed = isset($arSql[0]) ? $arSql[0] : array();
		$arSql2 = $oDb->sqlExec($oSqlQ->getQ('get-custompages-lang-adm', $tid), 'page');
		$arParsed['page'] = $arSql2;
		$arParsed['ar'] = $arSqlc;
		$is_first = 1;
		if (is_array($arPre))
		{
			$is_first = 0;
			$arParsed = gw_ParsePre($arParsed, $arPre);
		}
		$strR .= getFormCustomPage($arParsed, $is_first, 0, $arReq);
	}
	else
	{
		/* Edited */
		/* Fix on/off options */
		$arIsV = array('is_active');
		for (; list($k, $v) = each($arIsV);)
		{
			$arPre[$v]  = isset($arPre[$v]) ? $arPre[$v] : 0;
		}
		/* final update */
#		$sys['isDebugQ'] = 1;

		$q1 = $q2 = array();
		$q1['id_parent'] = $arPre['id_parent'];
		$q1['is_active'] = $arPre['is_active'];
		$q1['page_icon'] = $arPre['page_icon'];
		$q1['page_php_1'] = $arPre['page_php_1'];
		$q1['page_php_2'] = $arPre['page_php_2'];
		$q1['page_uri'] = $arPre['page_uri'];
		$q1['date_modified'] = gmmktime();
		/* */
		$queryA[] = 'DELETE FROM ' . TBL_CUSTOMPAGES_PH. ' WHERE id_page = "' . $tid . '"';
		$id_page_phrase = $oDb->MaxId(TBL_CUSTOMPAGES_PH, 'id_page_phrase');
		for (; list($elK, $arV) = each( $arPre['page']);)
		{
			$q2['page_title'] = $arV['page_title'];
			$q2['page_descr'] = $arV['page_descr'];
			$q2['page_content'] = $arV['page_content'];
			$q2['id_lang'] = $arV['id_lang'];
			$q2['id_page_phrase'] = ($arV['id_page_phrase'] == '') ? $id_page_phrase+$elK : $arV['id_page_phrase'];
			$q2['id_page'] = $tid;
			$queryA[] = gw_sql_insert($q2, TBL_CUSTOMPAGES_PH, 'id_page_phrase = "' . $arV['id_page_phrase'] .'"');
		}
		$queryA[] = gw_sql_update($q1, TBL_CUSTOMPAGES, 'id_page = "' . $tid.'"');
		$strR .= postQuery($queryA, 'a=' . BRWS . '&'.GW_TARGET.'='.GW_T_CUSTOMPAGE, $sys['isDebugQ'], 0);
	}

##
## --------------------------------------------------------
break;
case GW_A_REMOVE:
## --------------------------------------------------------
## Remove selected custom page
	/* Check permissions */
	if (!$oSess->is('sys_settings'))
	{
		$strR .= $oL->m('reason_13');
		break;
	}
	$sys['isDebugQ'] = 0;
	$isError = 0;
	if (!$isError)
	{
		if (!$isConfirm)
		{
			/* Not saved */
			$arSql2 = $oDb->sqlExec($oSqlQ->getQ('get-custompages-lang-adm', $tid), 'page');

			$Confirm = new gwConfirmWindow;
			$Confirm->action = $sys['page_admin'];
			$Confirm->submitok = $oL->m('3_remove');
			$Confirm->submitcancel = $oL->m('3_cancel');
			$Confirm->formbgcolor = $GLOBALS['theme']['color_2'];
			$Confirm->formbordercolor = $GLOBALS['theme']['color_4'];
			$Confirm->formbordercolorL = $GLOBALS['theme']['color_1'];
			$Confirm->setQuestion('<p class="r"><span class="s"><b>' . $oL->m('9_remove') .
										'</b></p><p class="t"><span class="f">'. $oL->m('3_remove').
										':</span><br/>' . $arSql2[0]['page_title'] . '</p>');
			$Confirm->tAlign = 'center';
			$Confirm->formwidth = '400';
			$Confirm->setField("hidden", "tid", $tid);
			$Confirm->setField("hidden", GW_ACTION, GW_A_REMOVE);
			$Confirm->setField("hidden", GW_TARGET, ${GW_TARGET});
			$Confirm->setField("hidden", GW_SID, ${GW_SID});
			$strR .= $Confirm->Form();
		}
		else
		{
			/* Create the list of subpages */
			$arSqlc = $oDb->sqlExec($oSqlQ->getQ('get-subpages-list', '', 0));
			$arSqlc = gw_rearrange_custompages($arSqlc);
			$arSqlc = gw_create_tree_custompages($arSqlc);
			$ar_nested_pages = ctlgGetTree($arSqlc, $tid);

			$queryA[] = 'DELETE FROM ' . TBL_CUSTOMPAGES . ' WHERE id_page IN (' . implode(',', $ar_nested_pages). ')';
			$queryA[] = 'DELETE FROM ' . TBL_CUSTOMPAGES_PH . ' WHERE id_page IN (' . implode(',', $ar_nested_pages). ')';
			$strR .= postQuery($queryA, GW_ACTION.'=' . BRWS . '&'.GW_TARGET.'='.GW_T_CUSTOMPAGE, $sys['isDebugQ'], 0);
		}
	}
	else
	{
		$strR .= '<p class="r"><span class="s">' . $oL->m('reason_11') . '</span> '.  $msgError . '</p>';
	}
##
## --------------------------------------------------------
break;
case UPDATE:
## --------------------------------------------------------
## Update page

	$arSql = $oDb->sqlExec($oSqlQ->getQ('get-pages-edit'), '', 0);
	$arSql3 = gw_rearrange_custompages($arSql);
	$arSql3 = gw_create_tree_custompages($arSql3);

	/* Up or Down */
	if ($mode == 'up' || $mode == 'dn')
	{
		$score = ($mode == 'up') ? "- 15" : "+ 15";
		$queryA = array();
		$sql = sprintf('UPDATE ' . TBL_CUSTOMPAGES . ' SET int_sort = int_sort %s WHERE id_page = "%d"', $score, $tid);
		$oDb->sqlExec($sql);
		$sql = sprintf('SELECT id_page FROM ' . TBL_CUSTOMPAGES . ' WHERE id_parent = "%d" ORDER BY int_sort ASC', $arSql3[$tid]['p']);
		$arSql = $oDb->sqlExec($sql);
		$i = 10;
		for (; list($arK, $arV) = each($arSql);)
		{
			$queryA[] = 'UPDATE ' . TBL_CUSTOMPAGES . '
						 SET int_sort = ' . $i . '
						 WHERE id_page = ' . $arV['id_page'];
			$i += 10;
		}
		postQuery($queryA, 'a=' . BRWS . '&'.GW_TARGET.'='.GW_T_CUSTOMPAGE, $sys['isDebugQ'], 0);
		exit($in); /* stop! */
	}
	elseif ($mode == 'reset')
	{
		$queryA = array();
		$i = 10;
		$arSql = $oDb->sqlExec($oSqlQ->getQ('get-custompages_id-by-p', $arSql3[$tid]['p']));
		for (; list($arK, $arV) = each($arSql);)
		{
			$queryA[] = sprintf('UPDATE ' . TBL_CUSTOMPAGES . '
						SET int_sort = "%d"
						WHERE id_page = "%d"',
						$i, $arV['id_page']
					);
			$i += 10;
		}
		postQuery($queryA, GW_ACTION.'=' . BRWS . '&'.GW_TARGET.'='.GW_T_CUSTOMPAGE, $sys['isDebugQ'], 0);
		exit($in); /* stop! */
	}

##
## --------------------------------------------------------
break;
default:
break;
} // end of switch

/* End of file */
?>