<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: t.sys.inc.php,v 1.13 2005/06/07 16:51:23 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2004 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Actions for a dictionary. Add, Browse, Edit, Remove, Update.
 */
/**
 * HTML-form for dictionary
 *
 * @param    array   $vars       posted variables
 * @param    int     $runtime    is this form posted first time [ 0 - no | 1 - yes ] // todo: bolean
 * @param    array   $arBroken   the names of broken fields (after post)
 * @param    array   $arReq      the names of required fields (after post)
 * @return   string  complete HTML-code
 * @see textcodetoform(), getFormHeight()
 */
function getFormSys($vars, $runtime = 0, $arBroken = array(), $arReq = array())
{
	global $a, $sys, $id, $tid, $topic_mode, $oFunc, $oL, ${GW_SID}, $gw_this;
	$topic_mode = 'form';
	$strForm = '';
	$trClass = 't';
	$v_class_1 = 'td1';
	$v_class_2 = 'td2';
	$v_td1_width = '25%';
	$trDisabled = 'disabled';
	$form = new gwForms();

	$form->Set('action', $GLOBALS['sys']['page_admin']);
	$form->Set('submitok', $oL->m('3_save'));
	$form->Set('submitcancel', $oL->m('3_cancel'));
	$form->Set('formbgcolor', $GLOBALS['theme']['color_2']);
	$form->Set('formbordercolor', $GLOBALS['theme']['color_4']);
	$form->Set('formbordercolorL', $GLOBALS['theme']['color_1']);
	$form->Set('align_buttons', $GLOBALS['sys']['css_align_right']);
	$form->Set('charset', $sys['internal_encoding']);
	
	$form->arLtr = array('arPost[y_email]',
						 'arPost[locale_name]', 'arPost[visualtheme]','arPost[path_log]',
						 'arPost[page_limit]', 'arPost[time_new]', 'arPost[time_upd]', 'arPost[defn_cut]',
						 );
	## ----------------------------------------------------
	##
	// reverse array keys <-- values;
	$arReq = array_flip($arReq);
	// mark fields as "REQUIRED" and make error messages
	while(is_array($vars) && list($key, $val) = each($vars) )
	{
		$arReqMsg[$key] = $arBrokenMsg[$key] = "";
		if (isset($arReq[$key])) { $arReqMsg[$key] = '&#160;<span class="red"><b>*</b></span>'; }
		if (isset($arBroken[$key])) { $arBrokenMsg[$key] = ' <span class="red"><b>' . $oL->m('reason_9') .'</b></span><br/>'; }
	} // end of while
	##
	## ----------------------------------------------------
	$form->setTag('select', 'class',  'input50');
	
	$strForm .= getFormTitleNav($oL->m('sect_general'), '');
	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';

	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('site_name') . ':' .  $arReqMsg["site_name"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['site_name'] . $form->field("input", "arPost[site_name]", textcodetoform($vars['site_name']), 255) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('site_desc') . ':' .  $arReqMsg["site_desc"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['site_desc'] . $form->field("input", "arPost[site_desc]", textcodetoform($vars['site_desc']), 255) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('contact_name') . ':' .  $arReqMsg["y_name"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['y_name'] . $form->field("input", "arPost[y_name]", textcodetoform($vars['y_name']), 127) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('contact_email') . ':' .  $arReqMsg["y_email"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['y_email'] . $form->field("input", "arPost[y_email]", textcodetoform($vars['y_email']), 127) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('keywords') . ':' .  $arReqMsg["keywords"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['keywords'] . $form->field("textarea", "arPost[keywords]", textcodetoform($vars['keywords']), $oFunc->getFormHeight($vars['keywords'])) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('default_lang') . ':' .  $arReqMsg["locale_name"] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['locale_name'] . $form->field("select", "arPost[locale_name]", $vars['locale_name'], 0, $oL->getLanguages()) . '</td>'.
				'</tr>';
	$strForm .= '</tbody></table>';

	$strForm .= getFormTitleNav($oL->m('sect_visual'), '');

	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('themename') . ':' .  $arReqMsg['visualtheme'] . '</td>'.
				'<td class="'.$v_class_2.'">' . $form->field("select", "arPost[visualtheme]", $vars['visualtheme'], 0, $gw_this['ar_themes']) . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $form->field('checkbox', 'arPost[is_list_numbers]', $vars['is_list_numbers']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_list_numbers_">' . $oL->m('1064') . '</label></td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $form->field('checkbox', 'arPost[is_list_images]', $vars['is_list_images']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_list_images_">' . $oL->m('1065') . '</label></td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $form->field('checkbox', 'arPost[is_list_announce]', $vars['is_list_announce']) . '</td>'.
				'<td class="'.$v_class_2.'"><label for="arPost_is_list_announce_">' . $oL->m('1066') . '</label></td>'.
				'</tr>';

	$form->setTag('input', 'class', '');
	$form->setTag('input', 'size', '4');
	$form->setTag('input', 'maxlength', '4');
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['page_limit'] . $form->field('input', "arPost[page_limit]", $vars['page_limit']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('page_limit') . $arReqMsg["page_limit"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['max_dict_updated'] . $form->field('input', "arPost[max_dict_updated]", $vars['max_dict_updated']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1062') .  $arReqMsg["max_dict_updated"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['max_dict_top'] . $form->field('input', "arPost[max_dict_top]", $vars['max_dict_top']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('1063') . $arReqMsg["max_dict_top"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['time_new'] . $form->field('input', "arPost[time_new]", $vars['time_new']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('time_new') . $arReqMsg["time_new"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['time_upd'] . $form->field('input', "arPost[time_upd]", $vars['time_upd']) . '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('time_upd') . $arReqMsg["time_upd"] . '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $arBrokenMsg['defn_cut'] . $form->field('input', "arPost[defn_cut]", $vars['defn_cut']) .  '</td>'.
				'<td class="'.$v_class_2.'">' . $oL->m('defn_cut') . $arReqMsg["defn_cut"] . '</td>'.
				'</tr>';
	$strForm .= '</tbody></table>';
	$form->setTag('input', 'class', 'input');
	$form->setTag('input', 'size', '20');


	$strForm .= getFormTitleNav($oL->m('sect_path'), '');

	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('path_log') . ':' .  '</td>'.
				'<td class="disabled">' . textcodetoform($sys['path_logs']). '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('path_cache') . ':' .  '</td>'.
				'<td class="disabled">' . textcodetoform($sys['path_cache_sql']). '</td>'.
				'</tr>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'">' . $oL->m('1068') . ':' .  '</td>'.
				'<td class="disabled">' . textcodetoform($sys['path_export']). '</td>'.
				'</tr>';


	$strForm .= '</tbody></table>';

	
	$strForm .= $form->field("hidden", GW_SID, ${GW_SID});
	$strForm .= $form->field("hidden", GW_ACTION, CFG);
	$strForm .= $form->field("hidden", GW_TARGET, SYS);


	return $form->Output($strForm);
}
// --------------------------------------------------------
$arReq = array(
	'path_tpl', 'path_log',  'path_cache',
	'site_name', 'site_desc', 'y_email', 'y_name', 'locale_name', 'visualtheme',
	'page_limit', 'time_new', 'time_upd', 'defn_cut', 'srch_len',
	'max_dict_updated', 'max_dict_top'
);
// --------------------------------------------------------
// Check permission
if ($oSess->have_perm('perm_admin'))
{
// --------------------------------------------------------
// action switcher
switch (${GW_ACTION})
{
case CFG:
## --------------------------------------------------------
##
	if ($post == '') // not saved
	{
		if (!isset($tid))
		{
			gwtk_header($sys['server_proto'].$sys['server_host'].$sys['page_admin']);
		}
		// set default values
		$arBroken   = array();
		$strR .= getFormSys($sys, 0, $arBroken, $arReq);
	}
	else // parse posted values
	{
		$arBroken = validatePostWalk($arPost, $arReq);


		/* Fix on/off options */
		$arIsV = array('is_list_numbers','is_list_images','is_list_announce');
		for (; list($k, $v) = each($arIsV);)
		{
			$arPost[$v]  = isset($arPost[$v]) ? $arPost[$v] : 0;
		}
			
		if (sizeof($arBroken) == 0)
		{
			$isPostError = 0;
		}
		else
		{
			$strR .= getFormSys($arPost, 1, $arBroken, $arReq);
		}
		if (!$isPostError) // final update
		{
			$sys['isDebugQ'] = 0;
			$arPost['is_cache'] = isset($arPost['is_cache']) ? 1 : 0;
			$arPost['cache_zlib'] = isset($arPost['cache_zlib']) ? 1 : 0;
			$arPost['page_limit'] = preg_replace("/[^0-9]/", '', $arPost['page_limit']);
			$arPost['time_new'] = preg_replace("/[^0-9]/", '', $arPost['time_new']);
			$arPost['time_upd'] = preg_replace("/[^0-9]/", '', $arPost['time_upd']);
			$arPost['defn_cut'] = preg_replace("/[^0-9]/", '', $arPost['defn_cut']);

			/* */
			for (reset($arPost); list($k, $v) = each($arPost);)
			{
				$q = array();
				$q['settings_key'] = $k;
				$q['settings_val'] = $v;
				$queryA[] = gw_sql_replace($q, TBL_SETTINGS);
#				$queryA[] = gw_sql_replace($q, TBL_SETTINGS, 'settings_key = "' . gw_text_sql($k) .'"');
			}
			$strR .= gw_tmp_clear();
			$strR .= postQuery($queryA, '', $sys['isDebugQ']);

		} // final update
	}
##
## --------------------------------------------------------
break;
default:
break;
} // end of switch
}

/* end of file */
?>