<?php
/**
 *  $Id: index.php,v 1.30 2005/06/08 09:51:43 yrtimd Exp $
 */
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2005 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
/* ------------------------------------------------------- */
/**
 *  Website
 */
/* ------------------------------------------------------- */
if (!defined('IN_GW'))
{
	define('IN_GW', true);
}
define('THIS_SCRIPT', 'index.php');
define('GW_IS_BROWSE_WEB',   1);
define('GW_IS_BROWSE_ADMIN', 0);
/* ------------------------------------------------------- */
/* Load configuration */
$sys['path_gwlib'] = 'lib';
$sys['path_include'] = 'inc';
$sys['path_include_local'] = 'inc';
$sys['is_prepend'] = 1;
include_once('db_config.php');
include_once($sys['path_include_local'] . '/config.inc.php');
/* --------------------------------------------------------
 * Database -> Query storage
 * ----------------------------------------------------- */
$oDb = new gwtkDb;
$oSqlQ = new $sys['class_queries'];
$oSqlQ->set_suffix('-'.$sys['db_type']);
/* ------------------------------------------------------- */
/* Append system settings */
$sys = array_merge($sys, getSettings());
/* Fill empty settings */
$sys['visualtheme'] = isset($sys['visualtheme']) ? $sys['visualtheme'] : 'gw_silver';
/* --------------------------------------------------------
 * mod_rewrite configuration
 * ------------------------------------------------------- */
$oHtml = new gw_html;
$oHtml->setVar('ar_url_append', $sys['ar_url_append']);
$oHtml->setVar('is_htmlspecialchars', 0);
$oHtml->setVar('is_mod_rewrite', $sys['is_mod_rewrite']);
$oHtml->setVar('mod_rewrite_suffix', ',xhtml');
$oHtml->setVar('mod_rewrite_index', 'i,xhtml');
$oHtml->setVar('server_dir', $sys['server_dir']);
$oHtml->setVar('mod_rewrite_rule',
	array('a=t'          => '/a/d/q',
		'a='.GW_A_LIST   => '/a/d/p,w1,w2',
		'a='.GW_A_PRINT  => '/a/q,t,d',
		'a=index'        => '/a/d/',
		'a='.GW_A_SEARCH => '',
		'a='.GW_T_TERM   => '/a/r/t,d',
		'a='.GW_A_CUSTOMPAGE => '/a/id',
		'/a/t')
);
if (($sys['is_mod_rewrite']) && (!preg_match("/\.php/", REQUEST_URI)))
{
	parse_str($oHtml->url_dir2str(REQUEST_URI), $_GET);
}
/* --------------------------------------------------------
 * Register global variables
 * ----------------------------------------------------- */
$gw_this['vars'] = $oGlobals->register(array(
	GW_ACTION,GW_ID_DICT,'p','r',GW_TARGET,'q','u','w1','w2','w','in','ie',
	GW_A_SEARCH,'arPost','strict','visualtheme',
	'id_srch','post','id','name','email','url','cookie','is_gzip','cookie',
	GW_LANG_I, GW_LANG_C, GW_SID
));
$oGlobals->do_default($gw_this['vars']['is_gzip'], $sys['is_use_gzip']);
$oGlobals->do_default($gw_this['vars'][GW_LANG_C], $gw_this['vars'][GW_LANG_I]);
$oGlobals->do_default($gw_this['vars']['lang_enc'], $sys['locale_name']);
/* Depreciated method */
for (reset($gw_this['vars']); list($k1, $v1) = each($gw_this['vars']);)
{
	$$k1 = $v1;
}
/* --------------------------------------------------------
 * Templates
 * ----------------------------------------------------- */
$oTpl = new gwTemplate();
$arTplVars['dict'] = $arTplVars['srch'] = array();
$oTpl->addVal( 'PATH_SERVER_URL', $sys['server_url'] );
$oTpl->addVal( 'PATH_SERVER_DIR', $sys['server_dir'] );
$oTpl->addVal( 'PATH_IMG',        $sys['path_img'] );
$oTpl->is_tpl_show_names = $sys['is_tpl_show_names'];
$gw_this['vars']['class_render'] = 'gw_render';
/* switch between `/index.php?a=action' and `/action/' (Apache mod_rewrite) */
if ($sys['is_mod_rewrite'])
{
	if (preg_match("/index\.php/", REQUEST_URI))
	{
		// redirect to a directory
		if( (REQUEST_URI != $sys['page_index'])
			&& !preg_match("/a=preferences/", REQUEST_URI)
			&& !preg_match("/a=srch/", REQUEST_URI)
			&& !preg_match("/q=/", REQUEST_URI)
			&& !preg_match("/a=fb/", REQUEST_URI) ) // convert for mod_rewrite
		{
			gwtk_header('http://' . HTTP_HOST . $oHtml->url_normalize(REQUEST_URI), 0);
		}
	}
}
unset($arPostVars);

## ---------------------------------------------------------
## printable version
$isPrint = 0;
if (${GW_ACTION} == GW_A_PRINT)
{
	${GW_ACTION} = GW_T_TERM;
	$isPrint = 1;
}
##
## ---------------------------------------------------------

/* Get the list of dictionaries */
$gw_this['ar_dict_list'] = getDictArray();

## ---------------------------------------------------------
## encrypted url
if (($t != '') && preg_match("/[a-f]/", $t))
{
	$u = $t;
	$udecoded = url_decrypt($sys['is_hideurl'], $u);
	if (!preg_match("/&d=/", $udecoded)){ $udecoded = url_decrypt(2, $u); }
	if (!preg_match("/&d=/", $udecoded)){ $udecoded = url_decrypt(1, $u); }
	if (!preg_match("/&d=/", $udecoded)){ $udecoded = url_decrypt(0, $u); }
	$u = $udecoded;
	if ($u != '')
	{
		$ar1 = split("&", $u);
		while(is_array($ar1) && list($k, $v) = each($ar1))
		{
			@list($k2, $v2) = split('=', $v);
			$$k2 = $v2;
		}
		$gw_this['vars'][GW_ID_DICT] = $d;
	}
	else
	{
		$layout = 'catalog';
	}
}
/* Not installed */
if (!isset($sys['version']))
{
	if (file_exists('gw_install/install.php'))
	{
		gwtk_header('http://' . HTTP_HOST . $sys['dirname'] . '/gw_install/install.php?step=novar', 0);
	}
	$sys['y_email'] = $sys['y_name'] = $sys['site_name'] = $sys['site_desc'] =
	$sys['is_polls'] = '';
	$sys['path_img'] = 'img';
	$sys['is_hideurl'] = $sys['time_new'] = $sys['time_upd'] = 1;
	$sys['version'] = 'not installed';
	$sys['locale_name'] = 'en-utf8';
}

// filtering GET vars...
#$t      = str_replace('.xhtml', '', $t); // compatibility for 1.4.x links
$in = ($in == '') ? 'both' : $in;
$p = ($p == '') ? 1 : $p;
$layout = ( !empty($a) ) ? $a : 'title';
// Strict search conditions:
// Dictionary ID > 0 and current page is not Search
$strict = ($strict == '') ? 0 : $strict;
// default value for $strict is 1 for dictionary pages
$strict = ((${GW_ACTION} != GW_A_SEARCH) && ($gw_this['vars'][GW_ID_DICT] > 0)) ? 1 : $strict;
$strict = ((${GW_ACTION} == GW_A_SEARCH) && ($gw_this['vars'][GW_ID_DICT] > 0) && $post != '') ? 1 : $strict;
$gw_this['vars'][GW_ID_DICT] = ((${GW_ACTION} == GW_A_SEARCH) && ($gw_this['vars'][GW_ID_DICT] > 0) && !$strict && ($id_srch == '')) ? 0 : $gw_this['vars'][GW_ID_DICT];
## ---------------------------------------------------------

// --------------------------------------------------------
// Load extensions: 27 aug 2003
// --------------------------------------------------------
$gw_this['vars']['funcnames'][GW_T_TERM] = isset($gw_this['vars']['funcnames'][GW_T_TERM]) ? $gw_this['vars']['funcnames'][GW_T_TERM] : array();
$gw_this['vars']['funcnames'][GW_T_DICT] = isset($gw_this['vars']['funcnames'][GW_T_DICT]) ? $gw_this['vars']['funcnames'][GW_T_DICT] : array();

// --------------------------------------------------------
// Load visual theme, last modified: 07 aug 2003
// --------------------------------------------------------
// Conditions:
// 1) set theme name to $sys['visualtheme'] if no custom theme name defined
// 2) set theme name to system theme for non-dictionary pages (title, top10, feedback, search)
// 3) set theme name to system theme for non-strict search (all dictionaries)
// 4) set theme name from dictionary settings if a dictionary ID was specified, search page also included

$isThemeLoaded = 0;
/* Dictionary selected */
if ($gw_this['vars'][GW_ID_DICT] > 0)
{
	/* Get dictionary settings */
	$arDictParam = getDictParam($gw_this['vars'][GW_ID_DICT]);
	/* Wrong dictionary ID number found, redirect */
	if (empty($arDictParam))
	{
		gwtk_header($sys['server_proto'].$sys['server_host'].$sys['page_index']);
	}
	/* */
	if (!$gw_this['vars']['visualtheme'])
	{
		$gw_this['vars']['visualtheme'] = $arDictParam['visualtheme'];
		$gw_this['vars']['visualtheme'] = (${GW_ACTION} == GW_A_SEARCH) ? $sys['visualtheme'] : $gw_this['vars']['visualtheme'];
		$gw_this['vars']['visualtheme'] = ($strict == 1) ? $arDictParam['visualtheme'] : $gw_this['vars']['visualtheme'];
	}
}
if (!$gw_this['vars']['visualtheme'])
{
	$gw_this['vars']['visualtheme'] = $sys['visualtheme'];
}

/* -------------------------------------------------------- */
/* Replace main page by title page */
if (($gw_this['vars'][GW_ID_DICT] == '') && ($a == ''))
{
	for (reset($gw_this['ar_dict_list']); list($kDict, $vDict) = each($gw_this['ar_dict_list']);)
	{
		$arDictParam = getDictParam($vDict['id']);
		if (isset($arDictParam['is_dict_as_index']) && $arDictParam['is_dict_as_index'])
		{
			$gw_this['vars'][GW_ID_DICT] = $vDict['id'];
			$layout = GW_A_LIST;
			/* Change theme name */
			$gw_this['vars']['visualtheme'] = $arDictParam['visualtheme'];
			break;
		}
		else
		{
			unset($arDictParam);
		}
	}
}
/* */
if (preg_match("/^[0-9a-z_-]+$/", $gw_this['vars']['visualtheme']))
{
	$themefile = $sys['path_tpl'] . '/' . $gw_this['vars']['visualtheme'] . '/theme.inc.' . $sys['phpEx'];
	if (file_exists($themefile))
	{
		$isThemeLoaded = 1;
		$sys['path_theme'] = $gw_this['vars']['visualtheme'];
	}
}
if (!$isThemeLoaded)
{
	$sys['path_theme'] = $sys['visualtheme'];
	$themefile = $sys['path_tpl'] . '/' . $sys['path_theme'] . '/theme.inc.' . $sys['phpEx'];
}
if (file_exists($themefile))
{
	include_once( $themefile );
}
else
{
	die('Can\'t find ' . $themefile);
}
$oTpl->addVal( 'V_THEME_NAME', $gw_this['vars']['visualtheme']);
$oTpl->addVal( 'PATH_CSS',     $sys['server_dir'] . '/' . $sys['path_tpl'] . '/' . $gw_this['vars']['visualtheme'] );
$oTpl->addVal( 'TABLEWIDTH',   $sys['tblwidth'] );
unset($themefile);
unset($isThemeLoaded);
/* --------------------------------------------------------
 * Set interface language, last modified: 10 mar 2004
 * ----------------------------------------------------- */
/* No custom language defined */
if ($gw_this['vars'][GW_LANG_I] == '')
{
	$gw_this['vars'][GW_LANG_I] = $sys['locale_name'];
	/* Get dictionary language */
	if (($gw_this['vars'][GW_ID_DICT] > 0) && isset($arDictParam['lang']))
	{
		$gw_this['vars'][GW_LANG_I] = ((${GW_ACTION} == GW_A_SEARCH) && !$strict)
									? $gw_this['vars'][GW_LANG_I]
									: $arDictParam['lang'];
		$gw_this['vars']['lang_enc'] = $arDictParam['lang'];
	}
	/* Cookie overwrites dictionary default language */
	if (isset($gw_this['cookie'][GW_LANG_I]) && $gw_this['cookie'][GW_LANG_I] == '')
	{
		$gw_this['cookie'][GW_LANG_I] = $gw_this['vars'][GW_LANG_I];
	}
	else if (isset($gw_this['cookie'][GW_LANG_I]))
	{
		$gw_this['vars'][GW_LANG_I] = $gw_this['cookie'][GW_LANG_I];
	}
}
$gw_this['vars'][GW_LANG_I] = preg_replace("/-([a-z0-9])+$/", '', $gw_this['vars'][GW_LANG_I]);
$gw_this['vars']['lang_enc'] = preg_replace("/^([a-z0-9])+-/", '', $gw_this['vars']['lang_enc']);

/* 25 sep 2002, Translation Kit */
$oL = new gwtk;
$oL->setHomeDir($sys['path_locale']);
$oL->setLocale($gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc']);
$gw_this['vars']['ar_languages'] = $oL->getLanguages();
/* Language files */
$oL->getCustom('actions', $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('err',     $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('options', $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('status',  $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('tdb',     $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('tht',     $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('tol',     $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
/* Uppercase / lowercase */
$oCase = new gwv_casemap(array(1,2,3,4,5,6,7,8), array(1,2,3,4,5));
$oCase->set_replace_sp(array('--'=>' ', '-' => ''));
// ---------------------------------------------------------
// Search engine, last modified 1 aug 2003
// ---------------------------------------------------------
// Set common variables for templates
$arTplVars['srch'] = array();

$arTplVars['srch'][] = array(
	'L_SRCH_TERM' => $oL->m('srch_1'),
	'L_SRCH_DEFN' => $oL->m('srch_0'),
	'L_SRCH_BOTH' => $oL->m('srch_-1'),
	'L_SRCH_PHRASE' => $oL->m('srch_phrase'),
	'L_SRCH_SUBMIT' => $oL->m('3_srch_submit'),
);
// Feature list of dictionary IDs
$gw_this['arDictListSrch'] = array();
//
// Search query, default values
if (!is_array($srch)) { $srch = array(); }
if (!isset($srch['by'])) { $srch['by'] = 'd'; } // search by dictionary
if (!isset($srch['in'])) { $srch['in'] = -1; }  // search in all elements
if (!isset($srch['adv'])) { $srch['adv'] = 'all'; } // seach all words
//
// Set switcher for HTML
$arTplVars['srch'][] = array('chk_srch_strict' => '' ); // search 'this dictionary only'
$arTplVars['srch'][] = array('chk_srch_all' => '' );
$arTplVars['srch'][] = array('chk_srch_exact' => '' );
$arTplVars['srch'][] = array('chk_srch_any' => '' );
$arTplVars['srch'][] = array('chk_srch_in_both' => '' );

// Web parameters conversion, old version
$srch['in'] = ($in == 'both') ? -1 : intval($srch['in']);
$srch['in'] = ($in == 'defn') ? 0 : intval($srch['in']);
$srch['in'] = ($in == 'term') ? 1 : intval($srch['in']);
$srch['in'] = ($in == 'syn') ? 7 : intval($srch['in']);
$srch['in'] = ($in == 'address') ? 9 : intval($srch['in']);
$srch['in'] = ($in == 'phone') ? 10 : intval($srch['in']);
//
// Go for each search option
if (isset($srch['adv']) && $srch['adv'] == 'all')
{
	$arTplVars['srch'][] = array('chk_srch_all' => ' checked="checked"' );
}
elseif (isset($srch['adv']) && $srch['adv'] == 'exact')
{
	$arTplVars['srch'][] = array('chk_srch_exact' => ' checked="checked"' );
}
elseif (isset($srch['adv']) && $srch['adv'] == 'any')
{
	$arTplVars['srch'][] = array('chk_srch_any' => ' checked="checked"' );
}
else // default
{
	$arTplVars['srch'][] = array('chk_srch_all' => ' checked="checked"' );
}
// Set switcher for HTML
// Where to search
if ($srch['in'] == '1')
{
	// search for term only
	$arTplVars['srch'][] = array('chk_srch_in_term' => ' checked="checked"' );
}
elseif (intval($srch['in']) == 0)
{
	// search in definitions
	$arTplVars['srch'][] = array('chk_srch_in_defn' => ' checked="checked"' );
}
elseif (intval($srch['in']) == -1)
{
	// search in terms and definitions, default
	$arTplVars['srch'][] = array('chk_srch_in_both' => ' checked="checked"' );
}
else
{
	// search for all fields
	$srch['in'] = array(0);
	$arTplVars['srch'][] = array('chk_srch_in_term' => ' checked="checked"' );
}
//
if (isset($srch['by']) && $srch['by'] == 'd')
{
	// Search by dictionary
	//
	// Set switcher for HTML
	$arTplVars['srch'][] = array('chk_srch_by_dict' => ' checked="checked"' );
	for (reset($gw_this['ar_dict_list']); list($kDict, $vDict) = each($gw_this['ar_dict_list']);)
	{
		if ($gw_this['vars'][GW_ID_DICT] == 0)
		{
			$gw_this['arDictListSrch'][] = $vDict['id'];
		}
		else
		{
			// TODO: search for multiple dictionaries
			$gw_this['arDictListSrch'][] = $gw_this['vars'][GW_ID_DICT];
			break;
		}
	}
}
elseif (isset($srch['by']) && $srch['by'] == 'tp')
{
	// Search by topics
	//
	// Set switcher for HTML
	$arTplVars['srch'][] = array('chk_srch_by_topic' => ' checked="checked"' );
	// Get topic's tree ID
	$gw_this['arTreeId'] = ctlgGetTree($gw_this['arTopics'], intval($arPost['id_tp']));
	for (reset($gw_this['ar_dict_list']); list($kDict, $vDict) = each($gw_this['ar_dict_list']);)
	{
		// check if dictionary presents in selected topic
		if (isset($gw_this['arTreeId'][$vDict['p']]))
		{
			$gw_this['arDictListSrch'][] = $vDict['id'];
		}
	}
}
else /* default */
{
	$arTplVars['srch'][] = array('chk_srch_by_dict' => ' checked="checked"' );
}
/* */
if ($strict) // check box for 'this dictionary only'
{
	$arTplVars['srch'][] = array('chk_srch_strict' => ' checked="checked"' );
}
// --------------------------------------------------------
// Load custom variables.
// Allows to alter default settings and keep sources clear
if (@file_exists('custom_vars.' . $sys['phpEx']))
{
	include_once('custom_vars.' . $sys['phpEx']);
}
/* ------------------------------------------------------- */
/* Load custom page constructor */
if (@file_exists('./'. 'custom_construct.' .$sys['phpEx']))
{
	include_once('./'. 'custom_construct.' .$sys['phpEx']);
}
else
{
	include_once($sys['path_include']. '/constructor.inc.' .$sys['phpEx']);
}
/* ------------------------------------------------------- */
/* Referer log */
if ($sys['is_LogRef'])
{
	if (!isset($oLog))
	{
		$oLog = new gw_logwriter($sys['path_logs']);
	}
	if ( ($HTTP_REF != '') && (!preg_match("/" . HTTP_HOST . '/', $HTTP_REF) ) )
	{
		$oLog->remote_ua = REMOTE_UA;
		$oLog->remote_ip = $oFunc->ip2int(REMOTE_IP);
		$oFunc->file_put_contents($oLog->get_filename('ref'), $oLog->get_str($HTTP_REF), 'a');
	}
}
/* ------------------------------------------------------- */
/* Custom constructor may change locale settings */
$oL->setLocale($gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc']);
/* Last header */
$oHdr->add('Content-Type: '.$sys['content_type'].'; charset='.$oL->languagelist('2'));
/* ------------------------------------------------------- */
/* Debug information */
if (DEBUG)
{
	include($sys['path_include'] . '/page.footer.' . $sys['phpEx']);
}
/* ------------------------------------------------------- */
/* Compile HTML-template */
$oTpl->parse();
$str_output = $oTpl->output();
/* Process text filters */
while (!$sys['is_debug_output']
		&& is_array($sys['filters_output'])
		&& list($k, $v) = each($sys['filters_output']) )
{
	$str_output = $v($str_output);
}
/* --------------------------------------------------------
 * GZip compression
 * ----------------------------------------------------- */
if ($sys['is_use_gzip'])
{
	/* Start time */
	if ($sys['is_LogGZip'])
	{
		$arLogGzip = array();
		if (!isset($oLog))
		{
			$oLog = new gw_logwriter($sys['path_logs']);
		}
		$arLogGzip[1] = strlen($str_output);
		$arLogGzip[3] = REMOTE_UA;
		$oTimer = new gw_timer('gzip');
	}
	/* requires $oHdr */
	$str_output = $oFunc->text_gzip($str_output, 9);
	/* End time */
	if ($sys['is_LogGZip'])
	{
		$arLogGzip[0] = sprintf("%1.5f", $oTimer->end());
		$arLogGzip[2] = strlen($str_output);
		if ($arLogGzip[1] != $arLogGzip[2])
		{
			$oFunc->file_put_contents($oLog->get_filename('gzip'), $oLog->make_str($arLogGzip), 'a');
		}
	}
}
/* --------------------------------------------------------
 * Final output
 * ----------------------------------------------------- */
$oHdr->output();
print $str_output;
/* end of file */
?>