<?php
/**
 * © 2004 Dmitry N. Shilnikov <dev at glossword.info>
 */
/* --------------------------------------------------------
 * $Id: class.case.php,v 1.1 2005/03/21 12:21:47 yrtimd Exp $
 * Helps to uppercase and lowercase characters
 * Removes special characters
 * Addition to Translation Kit, http://glossword.info/tkit/
 * ----------------------------------------------------- */
$tmp['mtime'] = explode(' ', microtime());
$tmp['start_time'] = (float)$tmp['mtime'][1] + (float)$tmp['mtime'][0];
/* ------------------------------------------------------*/
$sys['class_case'] = 'gwv_casemap';
class gwv_casemap
{
	/* Case mapping */
	var $ar = array();
	/* Special characters mapping */
	var $arsp = array();
	/* Array with profiles, Latin (1) */
	var $arp = array(1);
	var $arp_sp = array(1);
	/* Enable usage of PHP-extension `mbstring' */
	var $is_use_mbstring = 1;
	/* No any of case mappings is in memory */
	var $is_loaded = 0;
	var $is_loaded_sp = 0;
	/* Autostart */
	function gwv_casemap($arp = array(1), $arp_sp = array(1))
	{
		$this->arp = $arp;
		$this->arp_sp = $arp_sp;
	}
	/* Reload settings */
	function reload($arp = array(1), $arp_sp = array(1))
	{
		$this->arp = $arp;
		$this->arp_sp = $arp_sp;
		$this->is_loaded = 0;
		$this->is_loaded_sp = 0;
	}
	/**
	 * @access private
	 */
	function _load_profile($ar = array(1))
	{
		/* Exit when `mbstring' is enabled or the casemap has been loaded before */
		if ((function_exists('mb_strtoupper')
			&& function_exists('mb_strtolower')
			&& $this->is_use_mbstring) || $this->is_loaded)
		{
			return;
		}
		$this->ar['lc'] = $this->ar['uc'] = $this->ar['nn'] = array();
		for (reset($ar); list($k, $v) = each($ar);)
		{
			$this->ar['lc'] = array_merge($this->ar['lc'], $this->_get_utf8_casemap('lc', $v));
			$this->ar['uc'] = array_merge($this->ar['uc'], $this->_get_utf8_casemap('uc', $v));
			$this->ar['nn'] = array_merge($this->ar['nn'], $this->_get_utf8_casemap('nn', $v));
		}
		$this->is_loaded = 1;
	}
	/* */
	function _load_profile_sp($ar = array(1))
	{
		if ($this->is_loaded_sp)
		{
			return;
		}
		$this->ar_sp = array();
		for (reset($ar); list($k, $v) = each($ar);)
		{
			$this->ar_sp = array_merge($this->ar_sp, $this->_get_specials($v));
		}
		$this->is_loaded_sp = 1;
	}
	/**
	 * Change a letter case
	 * @access private
	 */
	function _c($t, $src = 'lc', $trg = 'uc')
	{
		/* Read settings */
		$is_use_mbstring = $this->is_use_mbstring;
		/* Disable usage of `mbstring' to allow custom case mapping */
		$this->is_use_mbstring = 0;
		$this->_load_profile($this->arp);
		/* Restore settings */
		$this->is_use_mbstring = $is_use_mbstring;
		if (isset($this->ar[$src]) && isset($this->ar[$trg]))
		{
			return str_replace($this->ar[$src], $this->ar[$trg], $t);
		}
		return $t;
	}
	/**
	 * Extended Uppercase function
	 * @access public
	 */
	function uc($t)
	{
		if (function_exists('mb_strtoupper') && $this->is_use_mbstring)
		{
			return mb_strtoupper($t, 'UTF-8');
		}
		return $this->_c($t, 'lc', 'uc');
	}
	/**
	 * Extended Lowercase function
	 * @access public
	 */
	function lc($t)
	{
		if (function_exists('mb_strtolower') && $this->is_use_mbstring)
		{
			return mb_strtolower($t, 'UTF-8');
		}
		return $this->_c($t, 'uc', 'lc');
	}
	/**
	 * Extended Uppercase function.
	 * Normaizes already uppercased or lowercased string
	 * @access public
	 */
	function nc($t)
	{
		return $this->_c($this->uc($t), 'uc', 'nn');
	}
	/**
	 * Script-based configuration
	 * @access private
	 */
	function _get_utf8_casemap($map = 'lc', $id_profile = 1)
	{
		/* 1 Latin */
		$nn['1'] = array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z');
		$uc['1'] = array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z');
		$lc['1'] = array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z');
		/* 2 Cyrillic: Russian, Mongolian */
		$nn['2'] = array('А', 'Б', 'В', 'Г', 'Д', 'Е', 'Е', 'Ж', 'З', 'И', 'Й', 'К', 'Л', 'М', 'Н', 'О', 'П', 'Р', 'С', 'Т', 'У', 'Ф', 'Х', 'Ц', 'Ч', 'Ш', 'Щ', 'Ъ', 'Ы', 'Ь', 'Э', 'Ю', 'Я');
		$uc['2'] = array('А', 'Б', 'В', 'Г', 'Д', 'Е', 'Ё', 'Ж', 'З', 'И', 'Й', 'К', 'Л', 'М', 'Н', 'О', 'П', 'Р', 'С', 'Т', 'У', 'Ф', 'Х', 'Ц', 'Ч', 'Ш', 'Щ', 'Ъ', 'Ы', 'Ь', 'Э', 'Ю', 'Я');
		$lc['2'] = array('а', 'б', 'в', 'г', 'д', 'е', 'ё', 'ж', 'з', 'и', 'й', 'к', 'л', 'м', 'н', 'о', 'п', 'р', 'с', 'т', 'у', 'ф', 'х', 'ц', 'ч', 'ш', 'щ', 'ъ', 'ы', 'ь', 'э', 'ю', 'я');
		/* 3 Basic diacritical signs: covers the most of European languages */
		$nn['3'] = array('A', 'A', 'A', 'A', 'A', 'A', 'A', 'Æ', 'C', 'E', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'I', 'Ñ', 'O', 'O', 'O', 'O', 'O', 'O', 'Ø', 'U', 'U', 'U', 'U', 'U', 'U', 'U', 'U', 'U', 'Y', 'Ү', 'Ө');
		$uc['3'] = array('À', 'Á', 'Â', 'Ǎ', 'Ã', 'Ä', 'Å', 'Æ', 'Ç', 'È', 'É', 'Ê', 'Ě', 'Ë', 'Ì', 'Í', 'Î', 'Ǐ', 'Ï', 'Ñ', 'Ò', 'Ó', 'Ô', 'Ǒ', 'Õ', 'Ö', 'Ø', 'Ù', 'Ú', 'Û', 'Ǔ', 'Ü', 'Ǖ', 'Ǘ', 'Ǚ', 'Ǜ', 'Ý', 'Ү', 'Ө');
		$lc['3'] = array('à', 'á', 'â', 'ǎ', 'ã', 'ä', 'å', 'æ', 'ç', 'è', 'é', 'ê', 'ě', 'ë', 'ì', 'í', 'î', 'ǐ', 'ï', 'ñ', 'ò', 'ó', 'ô', 'ǒ', 'õ', 'ö', 'ø', 'ù', 'ú', 'û', 'ǔ', 'ü', 'ǖ', 'ǘ', 'ǚ', 'ǜ', 'ý', 'ү', 'ө');
		/* 4 Cyrillic Extended: Tatar, Kalmyk */
		$nn['4'] = array('Г', 'Є', 'Ѕ', 'I', 'I', 'J', 'К', 'У', 'Џ', 'Г', 'Љ', 'Њ', 'ћ', 'Ђ', 'Ҋ', 'Ҍ', 'Ҏ', 'Ґ', 'Ғ', 'Ҕ', 'Җ', 'Ҙ', 'Қ', 'Ҝ', 'Ҟ', 'Ҡ', 'Ң', 'Ҥ', 'Ҧ', 'Ҩ', 'Ҫ', 'Ҭ', 'Ү', 'Ұ', 'Ҳ', 'Ҵ', 'Ҷ', 'Ҹ', 'Һ', 'Ҽ', 'Ҿ', 'Ӂ', 'Ӄ', 'Ӆ', 'Ӈ', 'Ӊ', 'Ӌ', 'Ӎ');
		$uc['4'] = array('Ѓ', 'Є', 'Ѕ', 'І', 'Ї', 'Ј', 'Ќ', 'Ў', 'Џ', 'Ґ', 'Љ', 'Њ', 'ћ', 'Ђ', 'Ҋ', 'Ҍ', 'Ҏ', 'Ґ', 'Ғ', 'Ҕ', 'Җ', 'Ҙ', 'Қ', 'Ҝ', 'Ҟ', 'Ҡ', 'Ң', 'Ҥ', 'Ҧ', 'Ҩ', 'Ҫ', 'Ҭ', 'Ү', 'Ұ', 'Ҳ', 'Ҵ', 'Ҷ', 'Ҹ', 'Һ', 'Ҽ', 'Ҿ', 'Ӂ', 'Ӄ', 'Ӆ', 'Ӈ', 'Ӊ', 'Ӌ', 'Ӎ');
		$lc['4'] = array('ѓ', 'є', 'ѕ', 'і', 'ї', 'ј', 'ќ', 'ў', 'џ', 'ґ', 'љ', 'њ', 'Ћ', 'ђ', 'ҋ', 'ҍ', 'ҏ', 'ґ', 'ғ', 'ҕ', 'җ', 'ҙ', 'қ', 'ҝ', 'ҟ', 'ҡ', 'ң', 'ҥ', 'ҧ', 'ҩ', 'ҫ', 'ҭ', 'ү', 'ұ', 'ҳ', 'ҵ', 'ҷ', 'ҹ', 'һ', 'ҽ', 'ҿ', 'ӂ', 'ӄ', 'ӆ', 'ӈ', 'ӊ', 'ӌ', 'ӎ');
		/* 5 Modern Greek */
		$nn['5'] = array('Α', 'Ε', 'Ι', 'Ι', 'Ο', 'Η', 'Υ', 'Υ', 'Ω', 'Α', 'Β', 'Γ', 'Δ', 'Ε', 'Ζ', 'Η', 'Θ', 'Ι', 'Κ', 'Λ', 'Μ', 'Ν', 'Ξ', 'Ο', 'Π', 'Ρ', 'Σ', 'Σ', 'Τ', 'Υ', 'Φ', 'Χ', 'Ψ', 'Ω','Ϙ','Ϛ','Ϝ','Ϟ','Ϡ','Ϣ','Ϥ','Ϧ','Ϩ','Ϫ','Ϭ','Ϯ');
		$uc['5'] = array('Ά', 'Έ', 'Ί', 'Ϊ', 'Ό', 'Ή', 'Ύ', 'Ϋ', 'Ώ', 'Α', 'Β', 'Γ', 'Δ', 'Ε', 'Ζ', 'Η', 'Θ', 'Ι', 'Κ', 'Λ', 'Μ', 'Ν', 'Ξ', 'Ο', 'Π', 'Ρ', 'Σ', 'Σ', 'Τ', 'Υ', 'Φ', 'Χ', 'Ψ', 'Ω','Ϙ','Ϛ','Ϝ','Ϟ','Ϡ','Ϣ','Ϥ','Ϧ','Ϩ','Ϫ','Ϭ','Ϯ');
		$lc['5'] = array('ά', 'έ', 'ί', 'ϊ', 'ό', 'ή', 'ύ', 'ϋ', 'ώ', 'α', 'β', 'γ', 'δ', 'ε', 'ζ', 'η', 'θ', 'ι', 'κ', 'λ', 'μ', 'ν', 'ξ', 'ο', 'π', 'ρ', 'σ', 'ς', 'τ', 'υ', 'φ', 'χ', 'ψ', 'ω','ϙ','ϛ','ϝ','ϟ','ϡ','ϣ','ϥ','ϧ','ϩ','ϫ','ϭ','ϯ');
		/* 6 Latvian, Czech */
		$nn['6'] = array('A', 'A', 'A', 'C', 'C', 'C', 'C', 'D', 'D', 'E', 'E', 'E', 'E', 'E', 'G', 'G', 'G', 'G', 'G', 'H', 'H', 'I', 'I', 'I', 'I', 'I', 'I', 'Ĳ', 'J', 'K', 'L', 'L', 'L', 'L', 'L', 'N', 'N', 'N', 'Ŋ', 'O', 'O', 'O', 'Œ', 'R', 'R', 'R', 'S', 'S', 'S', 'S', 'S', 'T', 'T', 'T', 'U', 'U', 'U', 'U', 'U', 'U', 'W', 'Y', 'Y', 'Z', 'Z', 'Z');
		$uc['6'] = array('Ā', 'Ă', 'Ą', 'Ć', 'Ĉ', 'Ċ', 'Č', 'Ď', 'Đ', 'Ē', 'Ĕ', 'Ė', 'Ę', 'Ě', 'Ĝ', 'Ğ', 'Ǧ', 'Ġ', 'Ģ', 'Ĥ', 'Ħ', 'Ĩ', 'Ī', 'Ĭ', 'Į', 'İ', 'I', 'Ĳ', 'Ĵ', 'Ķ', 'Ĺ', 'Ļ', 'Ľ', 'Ŀ', 'Ł', 'Ń', 'Ņ', 'Ň', 'Ŋ', 'Ō', 'Ŏ', 'Ő', 'Œ', 'Ŕ', 'Ŗ', 'Ř', 'Ś', 'Ŝ', 'Ş', 'Ș', 'Š', 'Ţ', 'Ť', 'Ŧ', 'Ũ', 'Ū', 'Ŭ', 'Ů', 'Ű', 'Ų', 'Ŵ', 'Ŷ', 'Ÿ', 'Ź', 'Ż', 'Ž');
		$lc['6'] = array('ā', 'ă', 'ą', 'ć', 'ĉ', 'ċ', 'č', 'ď', 'đ', 'ē', 'ĕ', 'ė', 'ę', 'ě', 'ĝ', 'ğ', 'ǧ', 'ġ', 'ģ', 'ĥ', 'ħ', 'ĩ', 'ī', 'ĭ', 'į', 'i', 'ı', 'ĳ', 'ĵ', 'ķ', 'ĺ', 'ļ', 'ľ', 'ŀ', 'ł', 'ń', 'ņ', 'ň', 'ŋ', 'ō', 'ŏ', 'ő', 'œ', 'ŕ', 'ŗ', 'ř', 'ś', 'ŝ', 'ş', 'ș', 'š', 'ţ', 'ť', 'ŧ', 'ũ', 'ū', 'ŭ', 'ů', 'ű', 'ų', 'ŵ', 'ŷ', 'ÿ', 'ź', 'ż', 'ž');
		/* 7 Vietnamese */
		$nn['7'] = array('A', 'A', 'A', 'A', 'A', 'A', 'A', 'A', 'A', 'A', 'A', 'A', 'E', 'E', 'E', 'E', 'E', 'E', 'E', 'E', 'I', 'I', 'O', 'O', 'O', 'O', 'O', 'O', 'O', 'O', 'O', 'O', 'O', 'O', 'U', 'U', 'U', 'U', 'U', 'U', 'U', 'U', 'Y', 'Y', 'Y', 'Y', 'W', 'W', 'W');
		$uc['7'] = array('Ạ', 'Ả', 'Ấ', 'Ầ', 'Ẩ', 'Ẫ', 'Ậ', 'Ắ', 'Ằ', 'Ẳ', 'Ẵ', 'Ặ', 'Ẹ', 'Ẻ', 'Ẽ', 'Ế', 'Ề', 'Ể', 'Ễ', 'Ệ', 'Ỉ', 'Ị', 'Ọ', 'Ỏ', 'Ố', 'Ồ', 'Ổ', 'Ỗ', 'Ộ', 'Ớ', 'Ờ', 'Ở', 'Ỡ', 'Ợ', 'Ụ', 'Ủ', 'Ứ', 'Ừ', 'Ử', 'Ư', 'Ữ', 'Ự', 'Ỳ', 'Ỵ', 'Ỷ', 'Ỹ', 'Ẁ', 'Ẃ', 'Ẅ');
		$lc['7'] = array('ạ', 'ả', 'ấ', 'ầ', 'ẩ', 'ẫ', 'ậ', 'ắ', 'ằ', 'ẳ', 'ẵ', 'ặ', 'ẹ', 'ẻ', 'ẽ', 'ế', 'ề', 'ể', 'ễ', 'ệ', 'ỉ', 'ị', 'ọ', 'ỏ', 'ố', 'ồ', 'ổ', 'ỗ', 'ộ', 'ớ', 'ờ', 'ở', 'ỡ', 'ợ', 'ụ', 'ủ', 'ứ', 'ừ', 'ử', 'ư', 'ữ', 'ự', 'ỳ', 'ỵ', 'ỷ', 'ỹ', 'ẁ', 'ẃ', 'ẅ');
		/* 8 Armenian */
		$nn['8'] = array('Ա', 'Բ', 'Գ', 'Դ', 'Ե', 'Զ', 'Է', 'Ը', 'Թ', 'Ժ', 'Ի', 'Լ', 'Խ', 'Ծ', 'Կ', 'Հ', 'Ձ', 'Ղ', 'Ճ', 'Մ', 'Յ', 'Ն', 'Շ', 'Ո', 'Չ', 'Պ', 'Ջ', 'Ռ', 'Ս', 'Վ', 'Տ', 'Ր', 'Ց', 'Ւ', 'Փ', 'Ք', 'Օ', 'Ֆ', '');
		$uc['8'] = array('Ա', 'Բ', 'Գ', 'Դ', 'Ե', 'Զ', 'Է', 'Ը', 'Թ', 'Ժ', 'Ի', 'Լ', 'Խ', 'Ծ', 'Կ', 'Հ', 'Ձ', 'Ղ', 'Ճ', 'Մ', 'Յ', 'Ն', 'Շ', 'Ո', 'Չ', 'Պ', 'Ջ', 'Ռ', 'Ս', 'Վ', 'Տ', 'Ր', 'Ց', 'Ւ', 'Փ', 'Ք', 'Օ', 'Ֆ', '՚');
		$lc['8'] = array('ա', 'բ', 'գ', 'դ', 'ե', 'զ', 'է', 'ը', 'թ', 'ժ', 'ի', 'լ', 'խ', 'ծ', 'կ', 'հ', 'ձ', 'ղ', 'ճ', 'մ', 'յ', 'ն', 'շ', 'ո', 'չ', 'պ', 'ջ', 'ռ', 'ս', 'վ', 'տ', 'ր', 'ց', 'ւ', 'փ', 'ք', 'օ', 'ֆ', '');
		/* 9 mail to <dev at glossword.info> if you need more language profiles */
		if (isset(${$map}[$id_profile]))
		{
			return ${$map}[$id_profile];
		}
		return $lc;
	}
	/**
	 * Database-driven configuration
	 * @access private
	 */
	function _get_utf8_casemap_db($map = 'lc', $id_profile = 1)
	{
		return array();
	}
	/* Remove everything */
	function rm_($t)
	{
		$t = ' '.$this->rm_crlf($t).' ';
		/* add space to HTML-tags */
		$t = str_replace('><', '> <', $t);
		$t = str_replace('<'.'?'.'php', '', $t);
		$t = strip_tags($t);
		/* remove comments? */
		/* remove {TEMPLATES} */
		$t = preg_replace("/\{([A-Za-z0-9:\-_]+)\}/", '', $t);
		$t = $this->rm_entity($t);
		$t = $this->rm_specials($t);
		$t = trim($t);
		return $t;
	}
	/* Remove new lines and tabs */
	function rm_crlf($t)
	{
		return preg_replace("/(\t|\r\n|\n|\r)/", ' ', $t);
	}
	/* Remove HTML-entitles */
	function rm_entity($t)
	{
		/* remove hex values first */
		/* then remove others */
		return preg_replace('/&[a-z]+;/', ' ', preg_replace('/&#[x0-9a-fA-F]+;/', ' ', $t));
	}
	/**
	 * Remove numeric values
	 * if (...min=2 and ...max=7) then (keep numbers),
	 * where the length is from 3 to 6.
	 * 12, 345, 5678, 8901234 => 345, 5678
	 * PHP 4.3.2
	 *
	 * @param $t       string   A text
	 * @param $int_min integer  Must be > 1
	 * @param $int_max integer  Must be > $int_min
	 */
	function rm_number($t, $int_min = 2, $int_max = 7)
	{
		if ($int_max == "0") { return $t; }
		if ($int_min < 0) { $int_min = 1; }
		if (($int_max != '')&&($int_max < $int_min)) { $int_max = $int_min + 1; }
/*		
		print('[0-9]{'. $int_min .','. $int_max .'}');
*/
		return preg_replace("/ [0-9]{". $int_min .','. $int_max ."}\b/u", ' ', $t);
	}
	/**
	 * Remove special characters
	 * @access public
	 */
	function rm_specials($t)
	{
		$this->_load_profile_sp($this->arp_sp);
		$t = str_replace(array_keys($this->ar_sp), array_values($this->ar_sp), $t);
		$t = preg_replace("/ {2,}/", ' ', $t);
		return $t;
	}
	/**
	 * Assign new replacement map for special characters
	 * @access public
	 */
	function set_replace_sp($ar)
	{
		if (!is_array($ar)){ return; }
		$this->_load_profile_sp($this->arp_sp);
		for (reset($ar); list($k, $v) = each($ar);)
		{
			$this->ar_sp[$k] = $v;
		}
	}
	/**
	 * Script-based configuration
	 * @access private
	 */
	function _get_specials($id_profile = 1)
	{
		/* Custom */
		$sp[1] = array('.'=>' ', '*'=>' ','?'=>' ');
		/* Basic special characters */
		$sp[2] = array('!'=>' ','"'=>' ','#'=>' ','$'=>' ','%'=>' ','&'=>' ','\''=>' ','('=>' ',')'=>' ','+'=>' ',','=>' ','-'=>' ','/'=>' ',':'=>' ',';'=>' ','<'=>' ','='=>' ','>'=>' ','@'=>' ','['=>' ','\\'=>' ',']'=>' ','^'=>' ','_'=>' ','`'=>' ','{'=>' ','|'=>' ','}'=>' ','~'=>' ',''=>' ','€'=>' ',''=>' ','‚'=>' ','ƒ'=>' ','„'=>' ','…'=>' ','†'=>' ','‡'=>' ','ˆ'=>' ','‰'=>' ','Š'=>' ','‹'=>' ','Œ'=>' ',''=>' ','Ž'=>' ',''=>' ',''=>' ','‘'=>' ','’'=>' ','“'=>' ','”'=>' ','•'=>' ','–'=>' ','—'=>' ','˜'=>' ','™'=>' ','š'=>' ','›'=>' ','œ'=>' ',''=>' ','ž'=>' ','Ÿ'=>' ',' '=>' ','¡'=>' ','¢'=>' ','£'=>' ','¤'=>' ','¥'=>' ','¦'=>' ','§'=>' ','¨'=>' ','©'=>' ','ª'=>' ','«'=>' ','¬'=>' ','­'=>' ','®'=>' ','¯'=>' ','°'=>' ','±'=>' ','²'=>' ','³'=>' ','´'=>' ','µ'=>' ','¶'=>' ','·'=>' ','¸'=>' ','¹'=>' ','º'=>' ','»'=>' ');
		/* Diacritics */
		$sp[3] = array('̀'=>'','́'=>'','̂'=>'','̃'=>'','̄'=>'','̅'=>'','̆'=>'','̇'=>'','̈'=>'','̉'=>'','̊'=>'','̋'=>'','̌'=>'','̍'=>'','̎'=>'','̏'=>'','̐'=>'','̑'=>'','̒'=>'','̓'=>'','̔'=>'','̕'=>'','̖'=>'','̗'=>'','̘'=>'','̙'=>'','̚'=>'','̛'=>'','̜'=>'','̝'=>'','̞'=>'','̟'=>'','̠'=>'','̡'=>'','̢'=>'','̣'=>'','̤'=>'','̥'=>'','̦'=>'','̧'=>'','̨'=>'','̩'=>'','̪'=>'','̫'=>'','̬'=>'','̭'=>'','̮'=>'');
		/* Chinese high specials and fullwidth characters */
		$sp[4] = array('！'=>' ','＂'=>' ','＃'=>' ','＄'=>' ','％'=>' ','＆'=>' ','＇'=>' ','（'=>' ','）'=>' ','＊'=>' ','＋'=>' ','，'=>' ','－'=>' ','．'=>' ','／'=>' ','０'=>'0','１'=>'1','２'=>'2','３'=>'3','４'=>'4','５'=>'5','６'=>'6','７'=>'7','８'=>'8','９'=>'9','：'=>' ','；'=>' ','＜'=>' ','＝'=>' ','＞'=>' ','？'=>' ','＠'=>' ','Ａ'=>'A','Ｂ'=>'B','Ｃ'=>'C','Ｄ'=>'D','Ｅ'=>'E','Ｆ'=>'F','Ｇ'=>'G','Ｈ'=>'H','Ｉ'=>'I','Ｊ'=>'J','Ｋ'=>'K','Ｌ'=>'L','Ｍ'=>'M','Ｎ'=>'N','Ｏ'=>'O','Ｐ'=>'P','Ｑ'=>'Q','Ｒ'=>'R','Ｓ'=>'S','Ｔ'=>'T','Ｕ'=>'U','Ｖ'=>'V','Ｗ'=>'W','Ｘ'=>'X','Ｙ'=>'Y','Ｚ'=>'Z','［'=>' ','＼'=>' ','］'=>' ','＾'=>' ','＿'=>' ','｀'=>' ','ａ'=>'a','ｂ'=>'b','ｃ'=>'c','ｄ'=>'d','ｅ'=>'e','ｆ'=>'f','ｇ'=>'g','ｈ'=>'h','ｉ'=>'i','ｊ'=>'j','ｋ'=>'k','ｌ'=>'l','ｍ'=>'m','ｎ'=>'n','ｏ'=>'o','ｐ'=>'p','ｑ'=>'q','ｒ'=>'r','ｓ'=>'s','ｔ'=>'t','ｕ'=>'u','ｖ'=>'v','ｗ'=>'w','ｘ'=>'x','ｙ'=>'y','ｚ'=>'z','｛'=>' ','｜'=>' ','｝'=>' ');
		/* Idegraphic special characters */
		$sp[5] = array('　'=>' ','、'=>' ','。'=>' ','〃'=>' ','〄'=>' ','々'=>' ','〆'=>' ','〇'=>' ','〈'=>' ','〉'=>' ','《'=>' ','》'=>' ','「'=>' ','」'=>' ','『'=>' ','』'=>' ','【'=>' ','】'=>' ','〒'=>' ','〓'=>' ','〔'=>' ','〕'=>' ','〖'=>' ','〗'=>' ','〘'=>' ','〙'=>' ','〚'=>' ','〛'=>' ','〜'=>' ','〝'=>' ','〞'=>' ');
		if (isset($sp[$id_profile]))
		{
			return $sp[$id_profile];
		}
		return array();
	}
	/**
	 * Database-driven configuration
	 * @access private
	 */
	function _get_specials_db($id_profile = 1)
	{
		return array();
	}
}
/* ------------------------------------------------------*/
$tmp['mtime'] = explode(' ', microtime());
$tmp['endtime'] = (float)$tmp['mtime'][1] + (float)$tmp['mtime'][0];
$tmp['time'][__FILE__] = ($tmp['endtime'] - $tmp['start_time']);
/* end of file */
?>